# Параметры запуска из командной строки

**Любой из параметров, кроме VAParams, можно передать в файле VAParams.json.**

| Параметр | Тип | Описание |
|--|--|--|
| VAParams | Строка |Путь к файлу json с основными настройками Vanessa-Automation. Устаревшее значение параметра: "VBParams". Доступные значения файла настроек [можно посмотреть тут](https://github.com/Pr-Mex/vanessa-automation/blob/develop/docs/JsonParams/JsonParamsRU.md)|
| StartFeaturePlayer | Булево | Параметр означает, что нужно запустить тесты на выполнение, согласно параметрам переданным в VAParams. Если параметр не указан, но передан параметр VAParams, то сценарии выполняться не будут, но будет выполнена загрузка настроек из файла указанного в VAParams.  |
| QuietInstallVanessaExt или ТихаяУстановкаVanessaExt | Булево | Выполняет тихую установку компоненты VanessaExt, без показа модального диалога пользователю. Для работы опции необходима установка толстого клиента платформы и возможность запускать файловые базы. |
| InstallVanessaExtOnFailOfQuietInstall | Булево | Указывает, что если не получилось сделать тихую установку компоненты все равно выполнять её подключение. Это имеет смысл, если Vanessa Automation запускается на компьютере, на котором ранее уже проводилась установка данной версии внешней компоненты VanessaExt, и поэтому не будет вызван модальный диалог, который платформа показывает при первой установке компоненты. |
| QuietInstallVanessaExtAndClose | Булево | Выполняет тоже самое, что и предыдущая опция, но после установки компоненты сеанс 1С буде закрыт. Тесты при этом выполняться не будут. Используется для гарантированной установки внешней компоненты до запуска основного сеанса тестирования. |
| UseFileBaseInstallationAlgorithmVanessaExt | Булево | Не рекомендуется использовать. Включает старый алгоритм установки компоненты VanessaExt, когда для подключения базы используется временная файловая база. |
| WorkspaceRoot | Строка | Определяет путь к каталогу проекта. По умолчанию каталогом проекта являет каталог, в котором находится основная обработка vanessa-automation.epf |
| ClearStepsCache | Булево |  Очищает кеш шагов при запуске Vanessa-Automation. Параметр может быть полезен, чтобы блокировать загрузку кеша шагов, который мог остаться у данного пользователя в данной базе. |
| DisableUserSettingsLoader | Булево | Отключает работу плагина "Загрузчик пользовательских настроек". Использование параметра уменьшает количество серверных вызовов, если не планируется использовать данный плагин. |
| DisableLoadTestClientsTable | Булево | Отключает загрузку списка клиентов тестирования. Параметр может быть полезен, чтобы блокировать загрузку списка клиентов тестирования, который мог остаться у данного пользователя в данной базе. |
| DisableLoadConfig | Булево |  Отключает загрузку настроек Vanessa-Automation. Параметр может быть полезен, чтобы блокировать загрузку настроек пользователя, которые могли остаться у данного пользователя в данной базе. |
| DisableFeatureLoadOnOpenForm | Булево |  Отключает загрузку фича файла при старте Vanessa-Automation. Аналогично установке {Объект.ЗагрузкаФичПриОткрытии = "Не загружать"} |
| DisableCheckPossibilityOfSynchronousCalls | Булево |  Отключает проверку возможности использования синхронных вызовов, несмотря на то, что в свойствах конфигурации они явно запрещены. Это нужно, т.к. в тонком клиенте часто возможно использовать синхронные вызовы несмотря на настройки конфигурации. |
| GetStepsCache | Булево | Служебный. Нужен при сборке Vanessa Automation Single. Т.к. Single уже внутри содержит всю библиотеку шагов. И сразу же содержит в себе рассчитанный кеш шагов. |
| DisableFileOptimization | Булево |  Служебный. Отключает механизм оптимизации работы с файлами для серверных баз, когда сервер запущен на том же ПК, что и клиент. Параметр используется для режима самотестирования Vanessa-Automation и использовать его в реальных запусках тестов не рекомендуется. |
| ShowMainForm | Булево |  Параметр включает отображение основной формы Vanessa-Automation, когда фреймворк запущен в пакетном режиме (когда передан параметр StartFeaturePlayer). Иначе в пакетном режиме основная форма отображаться не будет. |
| UseEditor | Булево |  Параметр включает инициализацию редактора при запуске Vanessa Automation из командной строки. По умолчанию редактор не инициализируется при запуске из командной строки для экономии ресурсов. |
| DisableFirstRunHelper | Булево |  Отключает помощник при первом запуске. |
| DisableAddStandartLibrary | Булево |  Отключает добавление в список библиотек стандартной библиотеки Vanessa Automation. Имеет сымсл для полной поставки и не имеет смысла для поставки Single. |
| GenerateSmokeTest | Булево |  Выполняет запуск генератора дымовых тестов. |
| DisableCloseSystemDialogsThatCanBeSkipped | Булево |  Отключает автоматическое закрытие системых диалогов, которые можно было бы закрыть и продолжить выполнение сценария. Если параметр не передан, то поведение по умолчанию такое, что если появился системный диалог, который прервал выполнения сценария и его можно закрыть и продолжить выполнение сценария, то будет выполнена попытка закрыть такой диалог и продолжить выполнение сценария. |

Данные параметры нужно передавать в командной строке запуска платформы в параметре /C. Например полная строка запуска может выглядеть так:

    "C:\Program Files (x86)\1cv8\8.3.23.1739\bin\1cv8c" /N"" /TestManager /Execute "C:\Commons\rep\vanessa-automation\vanessa-automation.epf" /IBConnectionString "File=""c:\Bases\TestBaseTestManager"";" /C"StartFeaturePlayer;QuietInstallVanessaExt;VAParams=C:\Temp\VAParams.json"

При передаче указанных выше параметров внутри параметра /C - их порядок не важен.
Также любой параметр из VAParams.json можно также передать в тексте командной строки. Можно передавать имя параметра как на русском, так и на английском языке.
Чтобы узнать имя настройки для данного элемента формы нужно навести курсор мышки на элемент формы Vanessa Automation и нажать сочетания клавиш ALT+H (должно быть выключено использование внешний компоненты).
Если параметр передан и в VAParams.json и в командной строке, то у значения из командной строки будет преимущество.
Значение и имя параметра разделяется символом равно "=". Параметры типа булево можно записывать, не указывая значение, для них значением по умолчанию считается Истина.
Если параметр имеет тип массив, например "Список тегов исключение", то значение нужно передавать в виде строки, где значения массива разделены запятыми.
Пример, когда параметр ignoretags передан как массив, у параметра ДелатьОтчетВФорматеАллюр указано значение, ОстановкаПриВозникновенииОшибки передан как булево:

    StartFeaturePlayer;VAParams=C:\Temp\VAParams.json;ignoretags=Тег1,Тег2;СписокТеговОтбор=Тег3,Тег4;ДелатьОтчетВФорматеАллюр=Ложь;ОстановкаПриВозникновенииОшибки;КаталогФич=c:\temp

Также любые параметры, указанные в этом файле или в файле VAParams.json можно передавать через переменные среды. Для этого нужно использовать формат **VANESSA_КЛЮЧ**.
Пример, когда через переменные среды передаётся флаг формирования отчета в формате Allure: **VANESSA_allurecreatereport**=true ИЛИ **VANESSA_ДелатьОтчетВФорматеАллюр**=true.
Пример, когда через переменные среды передаётся КаталогПроекта: **VANESSA_КаталогПроекта**=C:\Temp\Project или **VANESSA_projectpath**=C:\Temp\Project

Важный момент. Механизм передачи значений через переменные среды предназначен для использования в CI контуре, т.е. когда передан параметр StartFeaturePlayer.
У параметра переданного черз переменную среды будет максимальный приоритет по сравнению с другими способами передачи параметра.
Если нужно запустить Vanessa Automation из командной строки и загрузить параметры при локальной работе по написанию тестов - нужно использовать загрузку параметров из файла VAParams.json.
Пример:

    VAParams=C:\Temp\VAParams.json

