﻿# Описание параметров, которые можно передавать в файле VAParams.json, который используется при запуске Vanessa Automation из командной строки.
#### Данный файл создан автоматически на основании данных формы Vanessa Automation. Пулреквесты нужно отправлять в подсказки к элементам формы.
#### Заготовку для этого файла можно получить выгрузив настройки Vanessa Automation в файл VAParams.json.

## Глобальные переменные

* Специальные

      * **GlobalVars {GlobalVars}**:
Структура, в которой будут находиться пары: ключ и значение. Данная структура будет загружена в глобальные переменные и эти переменные будут доступны при выполнении сценария в объекте КонтекстСохраняемый.

## Основные

   * **КаталогФич {featurepath}**:
      Каталог фича файлов или имя одного фича файла, которые будут выполняться во время сессии тестирования.

*  Отбор по тегам

      * **СписокТеговИсключение {ignoretags}**:
         В поле указываются теги. Если тег будет найден в фиче, то вся фича не будет загружена. Если тег будет найден у сценария, то не будет загружен только этот сценарий.

      * **СписокТеговОтбор {filtertags}**:
         В поле указываются теги. Если тег НЕ будет найден в фиче, то вся фича не будет загружена. Также возможно загрузить из фичи только те сценарии, у которых указаны нужные теги из списка.

*  Отбор по сценариям

      * **СписокСценариевДляВыполнения {scenariofilter}**:
         Позволяет задать порядок выполнения сценариев. Сценарии будут выполняться в том порядке как они указаны в списке.
         Плюс позволяет задать фильтр на выполнение сценариев. Будут выполняться только сценарии из списка.
         Сценарий в списке указывается с помощью его имени.

*  Язык фича файлов

      * **ЯзыкГенератораGherkin {gherkinlanguage}**:
         Поле задаёт язык, на котором будет генерироваться текст сценария при накликивании. Также, если выбран язык отличный от русского, то при выборе шага из базы "известных шагов" также появятся дополнительные колонки, которые отображают текст и описание шага на выбранном языке.

*  Запись действий пользователя

      * **ДобавлятьПриНакликиванииМетаИнформацию {addmetainformationclicking}**:
         Если флаг установлен, то при генерации текста сценария после накликивания будет добавляться информация, необходимая для перевода сценария на другой язык в будущем.

      * **ИскатьЭлементыФормыПоИмени {searchformelementsbyname}**:
         Если флаг установлен, то при генерации текста сценария после накликивания, шаги в сценарии будут искать элементы формы по внутреннему имени.
         Если флаг снят, то при генерации текста сценария после накликивания, шаги в сценарии будут искать элементы формы по заголовку, если это возможно.
         Это возможно в том случае, если в данной форме есть только один элемент с данным заголовком.

      * **ПоказыватьОкноОстановкиЗаписиДействийПользователя {ShowWindowToStopRecordingUserActions}**:
         Включает показ дополнительного окошка для удобной остановки записи действий пользователя и переключения в окно Vanessa Automation. Необходимо включить использование компоненты VanessaExt.

*  Внешняя компонента VanessaExt

      * **ИспользоватьКомпонентуVanessaExt {useaddin}**:
         Предназначена для управления окнами Windows и Linux. 
         Возможности:
         Получение списка окон и списка процессов
         Управление размерами и положением окна
         Получение снимка окна и снимка экрана
         https://github.com/lintest/VanessaExt

      * **ИспользоватьПарсерGherkinИзКомпонентыVanessaExt {usethegherkinparserfromthevanessaextaddin}**:
         Устанавливает признак того. что нужно использовать парсер Gherkin из компоненты VanessaExt. Этот парсер работает гораздо быстрее, чем встроенный парсер.

      * **ПоискФайловСПомощьюКомпонентыVanessaExt {SearchingForFilesUsingTheVanessaExtComponent}**:
         Включает поиск файлов с помощью внешней компоненты VanessaExt.

      * **ЗавершатьРаботуЕслиНеПолучилосьВыполнитьТихуюУстановкуКомпоненты {QuitIfSilentInstallationAddinFails}**:
         Если флаг установлен и не получилось выполнить тихую установку внешней компоненты работа сеанса будет завершена с кодом возврата 4.
         Возможные статусы возврата:
         https://github.com/Pr-Mex/vanessa-automation/blob/develop/docs/ReturnStatus/ReturnStatus.md

*  Системные каталоги

      * **КаталогПроекта {projectpath}**:
         Каталог, где находятся файлы тестируемого проекта, необходимые для выполнения тестов.

      * **ИспользоватьШаблонНовойФичи {UseTemplateForNewFeature}**:
         Если указан шаблон (в формате *.txt), то новый сценарий будет создаваться из него

      * **КаталогИнструментов {instrpath}**:
         Каталог, где находится обработка Vanessa Automation. При работе со стандартной поставкой поле должно быть заполнено.
         При работе с Vanessa Automation Single допускается оставлять поле пустым.

      * **КаталогВременныхФайлов {TemporaryFilesDirectory}**:
         Каталог, в котором будут создаваться временные файлов скриптов.
         Если указано значение настройки - тогда временные файлы скриптов будут создаваться в нём. Если значение настройки не указано, тогда будет использоваться временный каталог пользователя. Обычно это
         "C:\USERS%username%\APPDATA\LOCAL\TEMP".
         Настройка нужна, т.к. Vanessa Automation может создавать bat файлы для запуска системных команд, а в некоторых ОС может быть установлен запрет на запуск таких файлов из временного каталога пользователя.

*  Дымовые тесты

      * **ДымовыеТестыКаталогВыходныхФайлов {SmokeTestsDirectoryOutputFiles}**:
         Каталог, в который будут записаны итоговые feature-файлы.

      * **ДымовыеТестыКаталогФайловИсключений {SmokeTestsDirectoryFileExceptions}**:
         Каталог, в котором хранятся текстовые файлы с объектами-исключениями. Для каждого вида объектов метаданных или события должен быть отдельный файл ("Справочники", "Документы" и т. д.).

      * **ДымовыеТестыПутьКФайлуНастроекСценариев {SmokeTestsPathToFileSettingsScripts}**:
         Путь к файлу настройки сценариев (файл настройки можно сформировать на закладке "Настройка сценариев" в окне "Генератор дымовых тестов").

      * **ДымовыеТестыОчищатьКаталогВыходныхФайлов {SmokeTestsCleanDirectoryOutputFiles}**:
         Если установлен, то feature-файлы в каталоге выходных файлов будут удалены перед началом формирования тестов.

      * **ДымовыеТестыТолькоВведенныеОбъекты {SmokeTestsOnlyEnteredObjects}**:
         При включении данного флага в формировании feature-файлов расширенных действий будут участвовать только объекты, для которых в текущей информационной базе существует хотя бы один не помеченный на удаление элемент.

      * **ДымовыеТестыТолькоИзмененныеОтностительноКонфигурацииПоставщика {SmokeTestsOnlyChangedRelativeToVendorConfiguration}**:
         При включении данного флага в формировании feature-файлов будут участвовать только объекты измененные относительно конфигурации поставщика. Для построения отчета о сравнении конфигураций будет запущен конфигуратор текущей информационной базы с текущим пользователем и пустым паролем. 

      * **ДымовыеТестыИмяКонфигурацииПоставщика {SmokeTestsVendorConfigurationName}**:
         Имя конфигурации поставщика для сравнения конфигураций.

*  Системные настройки

      * **ТегTreeВключенПоУмолчанию {thetreetagisenabledbydefault}**:
         Если флаг установлен, то считается, что в фича файл написан так, как будто в нём указан тег @tree, даже если его там нет. Т.е. считается, что любой загружаемый фича файл использует иерархию шагов.

      * **ВычислятьВыраженияВФигурныхСкобках {EvaluateExpressionsInCurlyBraces}**:
         Включает режим, когда любое выражение внутри параметров шагов {} будет вычисляться. Если объявлена секция "Переменные", то значение настройки игнорируется, вычисление выражений включается во всём файле, сначала будет произведена попытка найти переменную из этой секции по указанному выражению. Иначе будет попытка вычислить выражение в {}.
         Если используются {выражение}, то выражение будет вычисляться на клиенте.
         Если используются {!выражение}, то выражение будет вычисляться на сервере.

*  Прочие настройки

      * **ЗагрузкаФичПриОткрытии {DownloadFeaturesOpen}**:
         Позволяет управлять поведением Vanessa Automation при открытии: нужно ли загружать фича файл, с которым велась работа в предыдущей, сессии или нет.

      * **ПоставщикПользовательскихНастроек {usersettingsprovider}**:
         Поставщик пользовательских настроек

      * **АдресПользовательскихНастроек {addressofcustomsettings}**:
         Файловый путь или url по которому находятся настройки. По умолчанию каталог проекта (имя файла по умолчанию user_settings.json)  или localhost.
         В результате чтения файла настроек будут созданы глобальные переменные.
         При запуске тестов из командной строки для создания переменных нужно передавать их в основном json файле настроек в параметре "GlobalVars", который является массивом значений вида Ключ:Значение.

      * **КомандаОткрытияФичиВТекстовомРедакторе {commandtoopenfeatureintexteditor}**:
         В поле указывается текстовый редактор, в котором будет открыт фича файл и спозиционирован на текущей строке, при выполнении команды "Открыть .feature файл в редакторе".

## Настройки клиентов тестирования

*  Запуск клиента тестирования

      * **ЗапускатьКлиентТестированияСМаксимизированнымОкном {runtestclientwithmaximizedwindow}**:
         Если опция включена клиент тестирования будет запущен развёрнутым на весь экран.

      * **МодальноеОкноПриЗапускеКлиентаТестированияЭтоОшибка {modalwindowwhenstartingtestclientiserror}**:
         Если опция включена, то модальное окно при запуске клиента тестирования означает ошибку подключения клиента тестирования.

      * **ПовторноЗапускатьСеансКлиентаТестированияПриПодключенииЕслиНеНайденЕгоПроцесс {starttestclientsessionagainonconnectionifitsprocessisnotfound}**:
         Включает повторный запуск процесса клиента тестирования, если предыдущий запуск не сработал (например, если не была получена лицензия). Только для толстого и тонкого клиента.

      * **ОпределятьРеальныйПортНаКоторомЗапустилсяКлиентТестирования {DetermineTheRealPortOnWhichTheTestingClientWasLaunched}**:
         Если опция включена, то при подключении клиента тестирования будет происходить попытка определить реальный порт, на котором был запущен клиент тестирования.
         Это нужно. т.к. клиент тестирования может поменять порт, на котором он запустился, несмотря на переданные параметры.
         Эта проблема актуальна при запуске тестов в Linux.

      * **ИнтервалЗапускаПроцессаКлиентаТестирования {testclientprocessstartinterval}**:
         Задаёт интервал, с которым будет производиться попытка запустить сеанс клиента тестирования.

      * **ТаймаутЗапуска1С {testclienttimeout}**:
         Устанавливает максимальное время в секундах, в течение которого Vanessa Automation будет ждать запуска клиента тестирования. По истечении времени будет вызвано исключение.

      * **ДиапазонПортовTestclient {testclientports}**:
         Устанавливает диапазон портов, в котором будет производиться поиск свободного порта в системе для запуска клиента тестирования. Например 48100-48200.

      * **КаталогФайловВыводаСлужебныхСообщений {DirectoryFilesOutputServiceMessages}**:
         Если параметр задан, то при запуске клиента тестирования будет добавляться параметр /Out <ИмяФайла>.
         Имя файла будет генерироваться по правилу ИмяКлиентаТестирования+ДатаВремяЗапуска.

      * **ОтключитьЗапускРеглЗаданийВФайловойБазе {DisableScheduledJobsExecutionForFileInfobase}**:
         Если опция включена, при запуске клиента тестирования в файловой базе будет отключен запуск регламентных заданий. Используется ключ командной строки /AllowExecuteScheduledJobs -Off

      * **РазрешеноЗапускатьТолькоОдинКлиентТестирования {OnlyOneTestClientAllowedToRun}**:
         Если опция включена, то будет включен контроль, что одновременно не может быть подключено более одного клиента тестирования.
         Это может быть полезно, если на компьютерах, на которых запускаются тесты, ограничен объем оперативной памяти и нужно контролировать запуск лишних процессов.

      * **ПроверкаСерверныхВызововВОбработчикахСобытий {CheckingServerCallsInEventHandlers}**:
         Добавляет к параметрам запуска клиентов тестирования строку /EnableCheckServerCalls.
         При завершении работы теста проверяет в окне "Информация для технической поддержки" наличие специальных сообщений о контекстных серверных вызовах.
         Если такие сообщения были найдены, то будет вызвана ошибка сценария.
         Подробная информация тут

*  Отладка клиента тестирования

      * **ЗапускатьТестКлиентВРежимеОтладки {testclientdebug}**:
         Если флаг установлен, то при запуске клиента тестирования ему будут переданы дополнительные ключи запуска /debug и /debuggerURL

      * **АдресОтладчика {testclientdebugaddress}**:
         Адрес отладчика, который будет передан клиенту тестирования.

      * **КлючиОтладки {testclientdebugkeys}**:
         Ключи отладки, которые будут переданы клиенту тестирования при запуске.

*  Запуск браузера

      * **КомандаЗапускаБраузера {browserlaunchcommand}**:
         В данном поле указывается команда запуска браузера. Если поле пустое, тогда для запуска web клиента будет использован браузер по умолчанию.
         Если в команде запуска браузера содержится строка "TestClientUrl", то она будет заменена на строку подключения клиента тестирования. Иначе строка подключения клиента тестирования будет добавлена в конец последним параметром.

      * **ИспользоватьБраузерПлюсWebSocket {usebrowserwebsocket}**:
         Позволяет выполнять внешние команды для браузера через WebSocket.
         Для работы опции необходимо включить использование компоненты VanessaExt.

*  Закрытие клиента тестирования

      * **ЗакрыватьКлиентТестированияПринудительно {forceclosetestclient}**:
         Если флаг установлен, то при закрытии клиента тестирования будет проверяться, закрылся ли клиент тестирования по его PID. Если клиент тестирования не закрылся штатно, то будет выполнена попытка закрыть его с помощью команды ОС.

      * **ТаймаутПередПринудительнымЗакрытиемКлиентаТестирования {timeoutbeforeforciblyclosingtestclient}**:
         Количество секунд, в течение которого будет проверяться, что процесс клиента тестирования завершился самостоятельно.

*  Мобильный клиент

      * **ПутьКadb {PathToadb}**:
         Путь к файлу программы adb

## Выполнение сценариев

*  Логирование и оповещение

      * **ДелатьЛогВыполненияСценариевВЖР {logtogr}**:
         Если флаг установлен, то в журнал регистрации будут записываться события о начале выполнения сценария и о начале выполнения шагов.

      * **ЗвуковоеОповещениеПриОкончанииВыполненияСценария {soundnotificationwhenscriptends}**:
         Если опция включена, то при окончании выполнения сценария будет выдаваться звуковое оповещение:
                 1. Сценарии выполнены успешно.
                 2. Ошибка при выполнении сценария.
                 3. Сработала точка останова.
         Необходимо включить использование компоненты VanessaExt.
         Опция работает только под Windows.

*  Скорость выполнения сценариев

      * **ВыполнятьШагиАсинхронно {makestepsasync}**:
         Если флаг установлен, то каждый шаг сценария будет выполняться асинхронно с указанным интервалом.
         Если флаг снят, то шаги будут выполняться синхронно. Дерево шагов при этом будет обновлять своё состояние каждый сотый шаг.
         При снятом флаге сценарий будет выполняться в несколько раз быстрее.

      * **ИнтервалВыполненияШагаЗаданныйПользователем {SpacingStepSpecifiedUser}**:
         Задаёт интервал выполнение между шагами сценария при асинхронном режиме выполнения шагов.

*  При возникновении ошибки

      * **ОстановкаПриВозникновенииОшибки {stoponerror}**:
         Если флаг установлен, то сценарии будут выполняться до первой ошибки.
         Все последующие сценарии выполняться не будут.

      * **ПоказыватьНомерСтрокиДереваПриВозникновенииОшибки {showrownumberonerror}**:
         Если флаг установлен, то при возникновении ошибки в дереве шагов будет показана колонка с номером строки в дереве, если эта колонка была скрыта.
         Актуально при работе в режиме дерева шагов.

*  Остановить выполнение сценария

      * **ПоказыватьОкноОстановкиВыполненияСценария {ShowWindowForStoppingScriptExecution}**:
         Включает показ дополнительного окна, которое позволяет остановить выполнение сценария. Необходимо включить использование компоненты VanessaExt.

      * **ИспользоватьДляОстановкиВыполненияСценарияФайл {UseAFileToStopScriptExecution}**:
         Если опция включена, то при нажатии кнопки остановки выполнения сценария в специальном окошке будет создаваться временный файл, а Vanessa Automation будет останавливать выполнение работы сценария, проверяя наличие этого файла.

*  Обновление статистики выполнения сценариев

      * **ОбновлятьСтатистикуВДереве {updatestatistics}**:
         Если флаг установлен, то во время выполнения сценария происходит обновление статистики: сколько шагов сценария прошло, сколько сценариев упало и так далее.

*  Стабилизация выполнения тестов

      * **КоличествоПопытокВыполненияСценария {NumberOfAttemptsToExecuteTheScript}**:
         Если в настройке указано значение более одного, тогда если сценарий не был выполнен успешно, будет выполнено ещё несколько попыток выполнения сценария.

      * **ОтключатьДляПолейВозможностьЗатиранияТекстаПриСерверномВызове {DisableForFieldsAbilityToOverwriteTextWhenServerCall}**:
         Существует проблема, что при синхронизации состояния формы после завершения серверного вызова, может затираться текст, который в данный момент редактирует пользователь.
         В тестах это может проявляться так, что тест ввёл значение в поле, но до того как он начал работать с другим полем данное значение было возвращено в предыдущее состояние.
         Данная опция включает механизм, когда свойство "ОбновлениеТекстаРедактирования" у полей формы, будет изменяться после вызова шага
         ```Gherkin
         Тогда открылось окно "ИмяОкна"
         ```
         Для работы опции в базе клиента тестирования должно быть установлено расширение VAExtension.

      * **КоличествоПопытокВыполненияДействия {numberofattemptstoperformanaction}**:
         Устанавливает количество попыток выполнения действий для многих шагов.
         Увеличение значения параметра может повысить стабильность выполнения сценариев на медленном железе.

      * **КоличествоСекундПоискаОкна {timetofindwindow}**:
         Максимальное время для поиска окна в шаге
         ```Gherkin
         Тогда открылось окно "ИмяОкна"
         ```

      * **ТаймаутДляАсинхронныхШагов {timeoutforasynchronoussteps}**:
         Указывает максимальное время ожидания для асинхронного шага.
         Например, если задано значение параметра равное 20 секунд и используется шаг
         ```Gherkin
         И я жду, что поле с именем "ИмяПоля" перестанет быть пустым в течение 10 секунд
         ```
         тогда в реальности максимальное время работы шага будет 20 секунд, а не 10.

      * **ПаузаПриОткрытииОкна {pauseonwindowopening}**:
         Значение дополнительной паузы, которая будет всегда применяться в шагах
         ```Gherkin
         Тогда открылось окно "ИмяОкна"
         И я жду открытия окна "Имя окна" в течении 60 секунд
         И я жду открытия окна отличного от "ИмяОкна" в течение 60 секунд
         ```

      * **МаксимальноеВремяВыполненияДействия {MaximumExecutionTimeAction}**:
         Устанавливает максимальное время выполнения действий, которые возвращают значение в менеджер тестирования.
         При превышении заданного времени генерируется исключение "Превышено максимальное время выполнения действия на стороне клиента тестирования". При этом выполнение действия будет продолжено.
         Если параметр равен 0, команды ожидают окончания выполнения без проверки времени прошедшего с начала выполнения.

      * **БезопасноеВыполнениеШагов {safeexecutionofsteps}**:
         Добавляет паузу при выполнении многих действий, которые потенциально могут приводить к нестабильному выполнению сценариев, например: переход к строке, проверка значения поля и т.д.
         Данная опция существенно замедляет выполнение сценариев.

*  Обновление данных в дереве в шагов

      * **ОбновлятьДеревоПриНачалеВыполненияСценария {updatetreewhenscenariostarts}**:
         Если флаг установлен, то при обновлении дерева шагов будет активизироваться текущая строка дерева. Рекомендуется снимать флаг при выполнении сценариев на CI сервере для ускорения выполнения сценариев.
         Актуально при работе в режиме дерева шагов.

*  Статусы сценариев

      * **ПриравниватьPendingКFailed {pendingequalfailed}**:
         Если флаг установлен, то при выполнении сценариев на CI сервере, если будут найдены нереализованные шаги ("Pending"/"Не реализовано") статус сборки всё равно будет "Failed"/"Ошибка".
         Флаг рекомендуется устанавливать.

      * **РазличатьBrokenИFailedПоКлючевомуСловуТогда {distinguishbrokenorfailedbythenkeyword}**:
         Если опция включена, то при возникновении ошибки статус сценария будет зависеть от того, с какого ключевого слова начинается шаг, на котором возникла ошибка. Если это слово Тогда, то статус сценария будет "Failed"/"Ошибка". Во всех остальных случаях - "Broken"/"Сломано". Это помогает различать сломанные тесты от реальных ошибок конфигурации.

*  Прочие настройки выполнения сценариев

      * **ВыполнятьSleepЧерезPing {dosleepusingping}**:
         Если опция включена, тогда вызов метода Sleep() будет происходить через вызов команды Ping. Это нужно в том случае, если в окне клиента тестирования в данный момент не отвечает на запросы.

      * **ЗапрещатьПерезаписыватьПеременные {banoverwritingvariables}**:
         Если флаг установлен, то при создании переменных во время выполнения шагов будет запрещено перезаписывать уже ранее объявленные переменные.

      * **ОбновлятьТаблицыФормыПриПолученииЗначения {updateformtableswhengettingvalue}**:
         Если опция включена, то при  получении таблицы тест будет пытаться найти и нажать на кнопку таблицы "Обновить" и нажать её.
         Попытка обновления будет происходить в том случае, если происходит несколько попыток получения значения таблицы и первая попытка была неуспешной.

      * **ПолучатьМакетыСПомощьюРасширенияVAExtension {getlayoutsusingextensionvaextension}**:
         Включает получение значений макетов (печатных форм и отчетов)  с помощью расширения VAExtension.
         Позволяет получать макет целиком с оформлением в web клиенте.

## Скриншоты

   * **ДелатьСкриншотПриВозникновенииОшибки {onerrorscreenshot}**:
      Включает снятие скриншотов при возникновении ошибки или по требованию (перед шагом указан тег @screenshot).
      Для работы опции необходимо, чтобы было заполнено поле "Команда создания скриншотов" либо подключена внешняя компонента VanessaExt.

   * **СниматьСкриншотКаждогоОкна1С {onerrorscreenshoteverywindow}**:
      Включает снятие скриншотов с каждого окна 1С при возникновении ошибки.
      Для работы опции используется SikuliX либо внешняя компонента VanessaExt (рекомендуется) в зависимости от настроек.

   * **ИспользоватьВнешнююКомпонентуДляСкриншотов {useaddinforscreencapture}**:
      Для снятия скриншотов используется компонента VanessaExt вместо команды создания скриншотов.
      Для работы опции необходимо включить использование внешней компоненты VanessaExt.

   * **СниматьСкриншотыБраузера {TakeBrowserScreenshots}**:
      Если опция включена, то при возникновении ошибки, когда браузер подключен через debug порт, будет выполнена попытка сделать скриншот браузера.

   * **КаталогВыгрузкиСкриншотов {outputscreenshot}**:
      Каталог, в который будут складываться скриншоты.

   * **СпособСнятияСкриншотовВнешнейКомпонентой {screencaptureaddinmethod}**:
      Весь экран - получает скриншот всего экрана, включая панель задач операционной системы.
      Текущее окно клиента тестирования - получает скриншот только активного окна клиента тестирования.
      Все окна клиента тестирования - получает скриншот всех окон клиента тестирования

   * **КомандаСделатьСкриншот {commandscreenshot}**:
      В поле указывается консольная команда, которая будет использоваться при снятии скриншотов.
      Например:
           1. "C:\Program Files (x86)\IrfanView\i_view32.exe" /capture=1 /convert=
           2. nircmd savescreenshot

## Отчет о запуске сценариев

*  Общие

      * **ДобавлятьКИмениСценарияУсловияВыгрузки {addtofeaturefilter}**:
         Данная опция используется, когда для нескольких похожих сборок (например запуск одних и тех же тестов) формируется один отчет (например Allure). Тогда, чтобы избежать неуникальности имен сценариев к имени сценария будет добавляться значение поля "Имя текущей сборки".

      * **ВыгружатьСтатусВыполненияСценариевВФайл {createlogs}**:
         Если флаг установлен, то Vanessa Automation будет выгружать статус выполнения сценариев в файл.
         Подробности тут:
         https://pr-mex.github.io/vanessa-automation/dev/ReturnStatus/ReturnStatus

      * **ИмяТекущейСборки {NameCurrentBuild}**:
         Уникальное имя сборки, которое используется совместно с параметром "Добавлять у имени сценария условия выгрузки".

      * **ПутьКФайлуДляВыгрузкиСтатусаВыполненияСценариев {logpath}**:
         Путь к файлу, в который будет выгружен статус выполнения сценариев.

*  Видеозапись прохождения тестов

      * **ЗаписыватьВидеоВыполненияТестов {recordtestrunvideo}**:
         Включает запись видео во время прохождения тестов. Необходимо включить использование внешней компоненты VanessaExt.
         Для каждого сценария будет создаваться свой видео файл.

      * **КоличествоКадровВидеоВыполненияТестов {thenumberofframesofvideotestsession}**:
         Количество кадров для записи видео.

      * **КомандаЗаписиВидеоВыполненияТестов {testrecordingvideocommand}**:
         Команда для запуска приложения "ffmpeg". Рекомендуется прописать путь к ffmpeg в системной переменной "path".

      * **КаталогДляЗаписиВидеоВыполненияТестов {directoryforrecordingvideotestexecution}**:
         Каталог для видео файлов.

*  Запись событий в файл или консоль

      * **ДелатьЛогВыполненияСценариевВТекстовыйФайл {logtotext}**:
         Включает вывод лога выполнения сценариев.
         В лог записываются события:
                 1. Начало выполнения сценария
                 2. Событие возникновения ошибки
         Вывод лога возможен либо в файл, либо в консоль, либо в файл и консоль одновременно.

      * **ВыводитьЛогВКонсоль {outputloginconsole}**:
         Включает вывод лога в консоль.
         Для работы опции необходимо включить использование компоненты VanessaExt.

      * **ВыводитьВЛогВыполнениеШагов {logstepstotext}**:
         Выводит в лог событие: начало выполнения шага.

      * **ПодробныйЛогВыполненияСценариев {fulllog}**:
         Больше деталей в логе
                 1. Количество тестов всего
                 2. Сколько упало/успешно/пропущено
                 3. Прошло/осталось времени

      * **ИмяФайлаЛогВыполненияСценариев {textlogname}**:
         Имя файла, куда будет выводиться лог Vanessa Automation.
         Если поле пустое - то лог в текстовый файл выводиться не будет.

*  Allure

   *  Основные настройки

         * **ДелатьОтчетВФорматеАллюр {allurecreatereport}**:
            Формировать отчет в формате Allure по результатам выполнения сценариев.

         * **ПодставлятьВОтчетеAllureЗначенияПеременных {setvariablevaluesinstepsallurereport}**:
            Если опция включена, то в параметрах шагов, в которых использовались переменные, имена переменных будут заменены на их значения.

         * **КаталогВыгрузкиAllure {allurepath}**:
            Каталог, в котором формируются данные отчета в формате Allure. При локальном запуске каталог будет очищаться при каждом запуске сценариев.

         * **КаталогВыгрузкиAllureБазовый {allurepathbase}**:
            Каталог, в котором формируются данные отчета в формате Allure, при этом для каждой сборки будет создаваться подкаталоги. Данный параметр имеет приоритет и значение параметра "Каталог отчета Allure" будет проигнорировано.

         * **УровеньОтчета1 {reportlevel1}**:
            Задаёт первый уровень группировки в отчете Allure на закладке Behaviors. Подробности описаны в справке.

         * **УровеньОтчета2 {reportlevel2}**:
            Задаёт второй уровень группировки в отчете Allure на закладке Behaviors. Подробности описаны в справке.

         * **УровеньОтчета3 {reportlevel3}**:
            Задаёт третий уровень группировки в отчете Allure на закладке Behaviors. Подробности описаны в справке.

         * **КаталогОтносительноКоторогоНадоСтроитьИерархию {directorytobuildhierarchy}**:
            Каталог, относительно которого рассчитывается иерархия фич. Подробности описаны в справке.

         * **ТегиПропускающиеСценарийAllure {tagsskippingscript}**:
            Список тегов, разделённых с помощью ";".
            Если в сценарии есть такой тег, тогда сценарий не будет выполняться и отчете Allure у него будет статус пропущен/skipped.

         * **ГруппировкаTestSuites {testsuites}**:
            Задаёт значение группировки в отчете Allure на закладке Suites. Подробности описаны в справке.

   *  Приложения к отчету

         * **ПрикладыватьКОтчетуAllureЖурналРегистрацииВыполненияСценария {attacheventlogtotheallurereport}**:
            При возникновении ошибки к сценарию будет приложен журнала регистрации. Данные берутся с момента начала выполнения сценария.

         * **ПрикладыватьКОтчетуAllureДанныеОСетевыхСоединениях {attachnetworkconnectiondatatotheallurereport}**:
            Если опция включена, то при возникновении ошибки будут собраны данные о сетевых соединениях ПК, на котором запускались тесты.

         * **ПрикладыватьКОтчетуAllureДанныеОСостоянииАктивнойФормы {attachactiveformdatatotheallurereport}**:
            Если опция включена, то при возникновении ошибки будут собраны данные о состоянии элементов активной формы в формате xlsx.

         * **ПрикладыватьКОтчетуAllureДанныеОСостоянииВсехФорм {attachallformsdatatotheallurereport}**:
            Если опция включена, то при возникновении ошибки будут собраны данные о состоянии элементов всех форм открытых в клиенте тестирования в формате xlsx.

         * **ПрикладыватьКОтчетуAllureДанныеОПроцессахОС {attachdataoftheoperatingsystemprocessestotheallurereport}**:
            Если опция включена, то при возникновении ошибки будут собраны данные о запущенных процессах ОС.

         * **ПрикладыватьКОтчетуAllureДанныеОЗначенияхПеременных {attachvariablestotheallurereport}**:
            Если опция включена, то при возникновении ошибки будут собраны данные со значениями переменных Контекста и Контекста глобального.

         * **ПрикладыватьФайлыMxlКОтчетуAllure {attachmxlfilestoallurereport}**:
            Файлы отчетов и их эталонов будут прикладываться к отчету Allure в формате mxl.

         * **ПрикладыватьФайлыMxlСохраненныеВФорматеHTMLКОтчетуAllure {attachmxlfilessavedinhtmlformattoallurereport}**:
            Все mxl файлы, которые будут приложены к отчету Allure будут сохраняться в формате HTML. Это упрощает открытие и просмотр результата.

         * **ПрикладыватьФайлыXlsxКОтчетуAllure {attachxlsxfilestoallurereport}**:
            Файлы отчетов и их эталонов будут прикладываться к отчету Allure в формате xlsx.

         * **ПрикладыватьДополнительныеДанныеПриСравненииЗначенияСЭталономAllure {attachadditionaldatawhencomparingvaluewithreferenceallure}**:
            Если опция включена, то при сравнении макета с эталоном или при сравнении таблицы с эталоном будут формироваться дополнительные файлы:
            картинка, содержащая разницу между эталоном и текущим значением таблицы или макета
            картинка текущего значения
            картинка эталонного значения
            файл в формате gif, показывающий разницу между текущим и эталонным значением.
            Также в отчете Allure появится дополнительная секция, где можно будет удобно просмотреть сравнение эталона и текущего значения.
            Для работы опции необходимо, чтобы на ПК, где запускается Vanessa Automation был установлен пакет ImageMagick7 версии или выше и пакет ghostscript https://www.ghostscript.com/download.html, который выполняет конвертацию pdf файлов в картинки.
            Также необходимо, чтобы на ПК выполнялись команды вида:
            magick convert file.pdf file.png
            Пример результата можно посмотреть тут.

   *  Данные аллюр меток

         * **ДанныеАллюрМеток {DataAllureMarks}**:
            Таблица используется для установки соответствия тегов сценариев меткам аллюра.
            Если в  строке таблицы указано регулярное выражение, то к каждому тегу сценария применяется регулярное выражение из данной таблицы и если тег ему соответствует, то к отчету будет добавлена метка в формате ИмяМетки:Значение.
            Если в строке таблицы регулярное выражение не указано, то метка добавляется безусловно.
            Подробнее зачем это может быть нужно можно прочитать тут
            https://habr.com/ru/company/sberbank/blog/359302/

*  JUnit

      * **ДелатьОтчетВФорматеjUnit {junitcreatereport}**:
         Формировать отчет в формате JUnit по результатам выполнения сценариев.

      * **КаталогВыгрузкиJUnit {junitpath}**:
         Каталог для формирования отчета.

      * **СкриншотыjUnit {junitscreenshots}**:
         С версии 13.12 в jUnit можно добавлять скриншоты.
         Чтобы все корректно работало - КаталогСкриншотов должен быть расположен внутри КаталогаПроекта.
         Папку скриншотов сохранять как артефакты.

*  СППР

      * **ДелатьОтчетВФорматеСППР {ModelingCreateReport}**:
         Формировать отчет в формате СППР по результатам выполнения сценариев.

      * **КаталогВыгрузкиСППР {modelingreportpath}**:
         Каталог для формирования отчета.

      * **ИмяКонфигурацииСППР {ModelingConfigurationName}**:
         Имя конфигурации для отчета

      * **ВерсияКонфигурацииСППР {ModelingConfigurationVersion}**:
         Версия конфигурации для отчета

*  Cucumber

      * **ДелатьОтчетВФорматеCucumberJson {cucumbercreatereport}**:
         Формировать отчет в формате Cucumber по результатам выполнения сценариев.

      * **КаталогВыгрузкиCucumberJson {cucumberreportpath}**:
         Каталог для формирования отчета.

*  Json

      * **ДелатьЛогОшибокВТекстовыйФайл {logerrorstotext}**:
         Формировать json файл для каждой ошибки, в котором будет подробная информация об ошибке.

      * **СобиратьДанныеОЗначенияхПеременных {CollectDataOnVariableValues}**:
         Включает сбор данных о значениях переменных.

      * **СобиратьДанныеОСостоянииАктивнойФормыПриОшибке {getactiveformdataonerror}**:
         Если опция включена, то при возникновении ошибки будут собраны данные о состоянии элементов активной формы в формате mxl.

      * **СобиратьДанныеОСостоянииВсехФормПриОшибке {getallformsdataonerror}**:
         Если опция включена, то при возникновении ошибки будут собраны данные о состоянии элементов всех форм открытых в клиенте тестирования в формате mxl.

      * **СобиратьДанныеОПроцессахОС {collectdataoftheoperatingsystemprocesses}**:
         Если опция включена, то при возникновении ошибки будут собраны данные о запущенных процессах ОС.

      * **СобиратьДанныеОСетевыхСоединениях {collectnetworkconnectiondata}**:
         Если опция включена, то при возникновении ошибки будут собраны данные о сетевых соединениях ПК, на котором запускались тесты.

      * **ИмяКаталогаЛогОшибок {texterrorslogname}**:
         Каталог, для формирования файлов с данными об ошибках и состоянии элементов форм и других данных, связанных с ошибкой. Каталог очищается при начале выполнения сценариев.

*  Внутренний формат

      * **ДелатьОтчетВоВнутреннемФормате {simplereport}**:
         Включает вывод отчет о запуске сценариев во внутреннем формате.

## Автоинструкции

*  UI Automation

      * **ИспользоватьUIAutomation {UseUIAutomation}**:
         Включает использование механизма UI Automation в Windows для эмуляции движения и кликов мышкой в шагах из стандартной библиотеки шагов Vanessa Automation.
         Например, когда опция выключена, шаг
         И я нажимаю на кнопку "ЗаголовокКнопки"
         просто нажмёт на кнопку не выполняя интерактивных действий.
         Если опция включена, то курсор мышки сначала будет перемещён к данной кнопке, а затем уже кнопка будет нажата.

*  Работа с браузером

      * **ИспользоватьБраузерПлюсWebSocket {usebrowserwebsocket}**:
         Позволяет выполнять внешние команды для браузера через WebSocket.
         Для работы опции необходимо включить использование компоненты VanessaExt.

      * **ИгнорироватьОшибкиПоискаЭлементовВБраузере {ignorebrowsersearcherrors}**:
         Позволяет не останавливать выполнение сценария если элемент формы не был найден в браузере.

      * **КоэффициентМасштабированияЭкрана {scalefactor}**:
         Значение по умолчанию равно единице. Если используется масштабирование экрана в ОС, тогда нужно изменять устанавливать соответствующее значение. Например, при масштабировании в 150% в ОС надо установить значение коэффициента 1.5.

*  Поиск картинок

      * **ПоискКартинокСПомощьюКомпонентыVanessaExt {findingpicturesusingaddinvanessaext}**:
         Если опция включена, то шаги, выполняющие поиск картинок на экране, будут использовать внешнюю компоненту VanessaExt вместо использования SikuliX.

      * **ПорогПоискаКартинки {PictureSearchThreshold}**:
         Число, определяющее порог поиска картинки на экране. Значение может быть задано в диапазоне от 0 до 1.

*  Эмуляция клавиатуры

      * **ЭмулироватьВводКлавиатурыVanessaExt {emulatekeyboardinputwithVanessaExt}**:
         Включает эмуляцию ввода клавиатуры с помощью компоненты VanessaExt

*  Эмуляция мышки

      * **ЭмулироватьДвиженияМышкиVanessaExt {emulatemousemovementswithVanessaExt}**:
         Включает эмуляцию движения мышки с помощью компоненты VanessaExt.

   *  Смещение координат мышки

         * **СмещениеПоГоризонталиДвиженияМышкиVanessaExt {hrizontaloffset}**:
            Используется, когда надо сместить положение мышки по горизонтали на заданное число пикселей. Может принимать как положительные, так и отрицательные значения.

         * **СмещениеПоВертикалиДвиженияМышкиVanessaExt {verticaloffset}**:
            Используется, когда надо сместить положение мышки по вертикали на заданное число пикселей. Может принимать как положительные, так и отрицательные значения.

   *  Скорость перемещения мышки

         * **КоличествоШаговПриДвиженииМышкиVanessaExt {thenumberofstepswhenmovingthemouse}**:
            Задаёт количество микродвижений (шагов), которая совершает мышка на своём пути. Значение по умолчанию 150.

         * **ПаузаМеждуШагамиПриДвиженииМышкиVanessaExt {timeoutbetweenstepswhenmovingthemouse}**:
            Задаёт паузу в миллисекундах между микро движениями мышки. Значение по умолчанию 3.

   *  Подсветка клика мышки

         * **ПодсвечиватьКликМышкиВБраузереVanessaExt {hlightmouseclicksinbrowser}**:
            Если опция включена, то будет включена подсветка кликов с помощью внешней компоненты VanessaExt.

      *  Выбор цвета подсветки кликов мышки

            * **ЦветПодсветкиКликаМышкиVanessaExt {mouseclickhighlightcolor}**:
               Число. Задаёт цвет, которым будут подсвечиваться клики мышки.

         * **РадиусПодсветкиКликаМышкиVanessaExt {mouseclickhighlightradius}**:
            Задаёт радиус анимации клика.

         * **ТолщинаПодсветкиКликаМышкиVanessaExt {mouseclickhighlightwidth}**:
            Задаёт толщину анимации клика.

         * **ДлительностьПодсветкиКликаМышкиVanessaExt {mouseclickhighlightduration}**:
            Задаёт длительность анимации клика.

         * **ПрозрачностьПодсветкиКликаМышкиVanessaExt {mouseclickhighlighttransparency}**:
            Задаёт прозрачность анимации клика.

*  Текстовые инструкции

      * **СоздаватьИнструкциюHTML {htmlcreate}**:
         Если флаг установлен, то во время выполнения сценария будет создаваться скринкаст в формате HTML.
         В поле "Команда создания скриншотов" должна быть указана консольная команда для снятия скриншотов.
         Также в тексте сценария возможно использовать специальные директивы, которые описаны в справке.

      * **КаталогВыгрузкиИнструкцийHTML {htmlpath}**:
         Каталог HTML инструкций

   *  Стили HTML

         * **ВариантСтилейHTMLИнструкции {VariantsHTMLInstructions}**:
            Вариант 3D Карусель - адаптирован как под ПК так и под мобильные устройства
            Подробности тут.

         * **СтилиHTMLИнструкции {htmlstyles}**:
            Файл стилей

         * **ВключитьОзвучкуHTML {EnableHTMLVoiceover}**:
            Используется встроенная в браузеры технология Синтеза речи. Синтез речи (text-to-speech или tts) подразумевает получение синтезированного текста приложения и его речевое воспроизведение.
            Подробнее
            Воспроизведение текста начинается при клике на картинку шага.

      * **СоздаватьИнструкциюMarkdown {markdowncreate}**:
         Если флаг установлен, то во время выполнения сценария будет создаваться скринкаст в формате MarkDown.
         В поле "Команда создания скриншотов" должна быть указана консольная команда для снятия скриншотов или установлен флаг скриншоты компонентой "VanessaExt".
         Также в тексте сценария возможно использовать специальные директивы, которые описаны в справке.

      * **КаталогВыгрузкиИнструкцийMarkdown {markdownpath}**:
         Каталог Markdown инструкций

      * **АвтонумерацияШагов {autonumberingofsteps}**:
         Добавляет авто нумерацию в начало текста описания шага. 
         Для того, чтобы лидирующие нули не терялись при экспорте из MD формата, текст записывается в блок кода.

      * **ТекстовыеИнструкцииГруппаШаговКакШаг {TextStepGroupAsStep}**:
         Включает режим, когда группа шагов в сценарии будет интерпретироваться как один шаг в текстовой инструкции.
         Если не указано дополнительных тегов, то скриншот будет сниматься после выполнения последнего шага в группе.
         Чтобы для  одной группы шагов сделать несколько скриншотов нужно использовать тег @screenshot перед нужными шагами.
         Если нужно сделать только один скриншот для группы шагов, то можно указать тег @screenshot только один раз перед нужным шагом.

      * **ДобавлятьИмяФичиВТекстовуюИнструкцию {AddFeatureNameToTextInstruction}**:
         Если флаг установлен, то в текстовую инструкцию будет добавлена информация с названием фичи.

      * **ДобавлятьИмяСценарияВТекстовуюИнструкцию {AddScenarioNameToTextInstruction}**:
         Если флаг установлен, то в текстовую инструкцию будет добавлена информация с названием сценария.

*  Аудио

   *  Общие

         * **ОзвучиватьВыполнениеСценария {soundscenarioexecution}**:
            Включает озвучку выполнения сценария согласно заданным настройкам голоса диктора.

   *  Озвучивание диктором

         * **ЗаписьВидеоТипОзвучкиTTS {ttstype}**:
            Указывает какой голос нужно использовать для озвучки видео диктором.

      *  Microsoft TTS

            * **ЗаписьВидеоПутьКДвижкуTTS {audioenginetts}**:
               Консольная команда, которая будет использована при конвертации текста в речь.
               Используется программа balabolka_console.

            * **ЗаписьВидеоИмяTTS {ttsvoice}**:
               Указывает какой голос будет использован для озвучки. Допускается указывать не полное название голоса в системе, а только часть, например "Elena".
               Понадобится установить Microsoft Speech Platform х32 и Server Runtime Languages.

            * **ЗаписьВидеоСкоростьПроизношения {speedofspeech}**:
               Скорость произношения текста диктором.
               Значения могут быть от -10 до 10.

      *  Yandex TTS

            * **ЗаписьВидеоYandexTTSЯзык {yandexttslanguage}**:
               Задаёт язык, на котором будет говорить диктор. Подробности здесь.
               Управление ударением и произношением см тут.

            * **ЗаписьВидеоYandexTTSГолос {yandexttsvoice}**:
               Задаёт голос, которым будет говорить диктор. Подробности здесь.
               Управление ударением и произношением см тут.

            * **ЗаписьВидеоYandexTTSЭмоция {yandexttsemotion}**:
               Задаёт эмоцию, с которой будет говорить диктор. Подробности здесь.
               Управление ударением и произношением см тут.

            * **ЗаписьВидеоYandexTTSСкорость {yandexttsspeed}**:
               Скорость (темп) синтезированной речи.
               Скорость речи задается дробным числом в диапазоне от 0.1 до 3.0.

            * **ЗаписьВидеоYandexTTSВариантЗапроса {yandexttsquerytype}**:
               Определяет как будут получены файлы озвучки: через официальное API или через бесплатный интерфейс. Рекомендуемое значение - через официальное API.

         *  Авторизация

               * **ЗаписьВидеоYandexTTSИдентификаторКаталога {yandexttsfolderId}**:
                  Последняя часть пути строки адреса в интернет браузере. https://console.cloud.yandex.ru/folders/ИдентификаторКаталога
                  Требуется:
                                   1. В главном окне Яндекс.Облако нажать на ссылку "Перейти в текущий каталог".
                                   2. Скопировать последнюю часть путь из строки адреса
                  Пример: 
                  https://console.cloud.yandex.ru/folders/b1gheo81t4a6eaafe5vd
                  (Идентификатор каталога - b1gheo81t4a6eaafe5vd)
                  Получение идентификатора каталога 

               * **ЗаписьВидеоYandexTTSOauthToken {yandexttsoauthtoken}**:
                  OAuth-токен используется в процедуре аутентификации в Яндекс.Облаке
                  Для получения OAuth-токена требуется:
                                   1. Перейти по ссылке https://cloud.yandex.ru/docs/iam/concepts/authorization/oauth-token;
                                   2. Сгенерировать токен;
                                   3. Сохранить его в текстовый файл;
                                   4. Указать путь к текстовому файлу с токеном.

               * **ЗаписьВидеоYandexTTSApiKey {yandexttsapikey}**:
                  API ключ используется в процедуре аутентификации в Яндекс.Облаке
                  https://cloud.yandex.ru/docs/iam/operations/api-key/create
                  Если указан, то авторизация будет через него, если нет, то будет через Токен

      *  Группа amazon TTS

            * **ЗаписьВидеоAmazonЯзык {amazonttslanguage}**:
               Соответствие языка и голоса смотрите здесь.

            * **ЗаписьВидеоAmazonГолос {amazonttsvoice}**:
               Соответствие языка и голоса смотрите здесь.

            * **ЗаписьВидеоAmazonДвижок {amazonttsengine}**:
               Варианты значения для поля "Движок" смотрите здесь.

            * **ЗаписьВидеоAmazonРегион {amazonttsregion}**:
               В поле указывается параметр регион. Значение по умолчанию: us-east-1.

            * **ЗаписьВидеоAmazonКлючДоступа {amazonttskey}**:
               Ключ доступа к облаку Amazon.

            * **ЗаписьВидеоAmazonСекретныйКлюч {amazonttssecretkey}**:
               Файл, в котором хранится секретный ключ для доступа к облаку Amazon.

      *  Группа другой движок TTS

            * **ЗаписьВидеоПутьКОбработкеДвижкаTTS {pathprocessingenginetts}**:
               Позволяет генерировать озвучку шага с помощью внешней обработки. Обработка должна в основной форме содержать экспортный метод:
               GetMp3File(Vanessa, VideoParams, Text, FileName, VoiceParams)
               где:
               Vanessa - Контекст фреймворка Vanessa Automation
               VideoParams - Структура, содержащая параметры записи видео
               Text - текст, который требуется озвучить
               FileName - имя текущего видеофрагмента
               VoiceParams - дополнительные параметры озвучки, указанные в фича файле с помощью дополнительных директив
               Метод должен возвращать путь к mp3 файлу.

            * **НастройкиДругогоДвижкаTTS {SettingsOtherEngineTTS}**:
               Позволяет задать произвольный набор настроек для генерации файлов озвучки.

      *  Параметры Сбер

            * **ЗаписьВидеоСберTTSClientID {sberttsclientid}**:
               Идентификатор клиента, полученный в Smartmarket studio

            * **ЗаписьВидеоСберTTSClientSecret {sberttsclientsecret}**:
               Вторая часть идентификации клиента в Smartmarket studio

            * **ЗаписьВидеоСберTTSГолос {sberttsvoice}**:
               Задает голос для генерации.
               Примеры голосов можно посмотреть здесь

      *  Тест голоса

   *  Кэш аудио

         * **ЗаписьВидеоКэшироватьФайлыTTS {cachettsfiles}**:
            Включает кэширование файлов озвучки.
            Ускоряет сборку видео.
            Позволяет сократить обращение к внешним сервисам для генерации речи.
            Позволяет сократить затраты на генерацию речи при использовании платных тарифов у сервисов генерации речи.

         * **ЗаписьВидеоКэшФайловTTS {ttsfilescache}**:
            Каталог, в котором хранится кэш файлов озвучки.

   *  Словари замен

         * **ЗаписьВидеоСловарьЗамен {changewordslib}**:
            Список файлов, которые будут использоваться для автозамены произносимого текста.

*  Видео

      * **СоздаватьИнструкциюВидео {videocreate}**:
         Позволяет создавать видео инструкции.
         Видео по описанию настроек находится в этом плей листе.
         Также рекомендуется прочитать этот FAQ. 

      * **КаталогВыгрузкиИнструкцийВидео {videopath}**:
         Каталог, в которой будут помещен результат сборки видео или анимированного скринкаста.

      * **ЗаписьВидеоФормироватьИнструкциюТипВидео {instructiontypevideo}**:
         Создавать видео инструкцию.

      * **ЗаписьВидеоФормироватьИнструкциюТипHTML {instructiontypehtml}**:
         Создавать анимированный скринкаст в формате HTML.

   *  Настройки видео

      *  Основные

            * **ЗаписьВидеоИнструмент {videocapturetool}**:
               Если выбран вариант VLC, тогда для записи видео будет вызываться инструмент VLC. Иначе будет использована внешняя компонента VanessaExt, которая будет вызывать ffmpeg.

            * **ЗаписьВидеоКоличествоКадров {fps}**:
               Задаёт количество кадров в секунду, снимаемых с экрана во время записи видео.

            * **ЗаписьВидеоКаталогДляВременныхФайлов {tempfolderforvideo}**:
               Рабочий каталог, в котором создаются промежуточные файлы во время записи и сборки видео. Каталог очищается перед каждой сборкой видео!

            * **ЗаписьВидеоКэшироватьВидеоВставки {cachevideo}**:
               Если флаг установлен то при работе шага
               И видеовставка "ТекстВставки"
               будет происходить проверка, есть ли в кэш уже такой видеофрагмент.
               Если в кэш фрагмента нет - он будет туда добавлен.
               Если фрагмент есть - то он будет взят из кэш.
               Установка флага ускоряет сборку видео.

            * **ЗаписьВидеоКэшВидеоВставок {videocachepath}**:
               Каталог, в котором хранятся фрагменты видеовставок.

      *  Экран

            * **ЗаписьВидеоЭкранШирина {screenwidth}**:
               Задаёт ширину экрана для записи видео. Значение не может быть больше чем ширина в текущем разрешении экрана. Если указать значение меньше, то в видео будет записываться часть экрана, начиная с верхнего левого угла.

            * **ЗаписьВидеоЭкранСлева {screenleft}**:
               Задает отступ слева

            * **ЗаписьВидеоЭкранВысота {screenheight}**:
               Задаёт высоту экрана для записи видео. Значение не может быть больше чем высота в текущем разрешении экрана. Если указать значение меньше, то в видео будет записываться часть экрана, начиная с верхнего левого угла.

            * **ЗаписьВидеоЭкранСверху {screentop}**:
               Задает отступ сверху

      *  Команды консоли

            * **ЗаписьВидеоКомандаFfmpeg {ffmpegcomand}**:
               Команда для работы и обработки видео. Также допускается указание полного пути к файлу ffmpeg.exe
               По умолчанию: ffmpeg

            * **ЗаписьВидеоКомандаConvert {convertcomand}**:
               В поле описывается как будет вызываться команда Convert.
               Для версии ImageMagick 7 достаточно указать "magick convert."
               Для более старых версий нужно указать путь к исполняемому файлу convert.exe в каталоге с программой ImageMagick.
               Пример:
               "C:\Program Files\ImageMagick-Х.Х.Х-Q16\convert.exe"
               Скачать: https://imagemagick.org/script/download.php
               Для версий младше 7 в процессе установки обязательным к установке является пункт: Install legacy utilities (e. g. convert)

         * **ЗаписьВидеоКомандаНачатьЗаписьВидео {comandrecvideo}**:
            Команда, которая будет запускать VLC для начала записи экрана. В команде возможно редактирование битрейта и других настроек.

   *  Настройки аудио

         * **ЗаписьВидеоДелатьНаложениеTTS {dotts}**:
            Включает озвучку видео диктором.

      *  Музыка

            * **ЗаписьВидеоКаталогМузыки {musicpath}**:
               Каталог, в котором находятся файлы в формате mp3.
               Если поле заполнено, то из каталога будет случайным образом взят mp3 файл, который будет использован для музыкальной подложки.
               Если длина mp3 файла меньше, чем длина результирующего видео, то аудио трек будет зациклен нужное количество раз, чтобы соответствовать длине видео файла.

            * **ЗаписьВидеоГромкостьМузыки {musicvolume}**:
               Возможно указывать значение от 0 до 1.
               Если значение поля 0, тогда громкость музыки изменяться не будет.
               Если указано значение отличное от нуля (например 0.06), тогда данное значение будет влиять на громкость музыкальной подложки.
               Чем больше значение - тем громче будет звучать музыкальная подложка.
               Рекомендуется указывать значение 0.1 или меньше.

   *  Дополнительно

         * **ЗаписьВидеоФайлКурсораМышки {mousecurfile}**:
            Путь к картинке, которая используется для отрисовки курсора мышки.

         * **ЗаписьВидеоФайлВодянойЗнак {watermarkfile}**:
            Картинка в формате png, которая будет использована для наложения водяного знака.
            Водяной знак будет расположен в правом нижнем углу видео.
            Разрешение картинки должно быть меньше, чем разрешение, в котором идёт запись видео.

         * **ЗаписьВидеоПроцентУскорения {accelerationpercentage}**:
            Максимальный процент ускорения, который возможен для фрагмента видео (одного шага видео).
            Механизм сборки видео может ускорить фрагмент видео, например, если длительность аудио трека для фрагмента была 5 секунд, а сам видео фрагмент получился 10 секунд.
            Если указано значение 0 - то ограничения на ускорение нет.
            Рекомендуется значение - 30%.
            Тогда в приведенном примере видео ускорится (5 * 1.3) с 5 секунд до 6.5 секунд.

         * **ЗаписьВидеоДобавлятьСубтитры {addsubtitles}**:
            Включает добавление субтитров встроенных в видео.

         * **ЗаписьВидеоГруппаШаговКакШаг {groupofstepsasastep}**:
            Включает режим, когда по умолчанию каждая группа шагов первого уровня в сценарии будет конвертироваться в один шаг в автоинструкции.

         * **ЗаписьВидеоСкрытьСлужебныеОкна {hideservicewindows}**:
            Скрывает служебные консольные окна, которые используются для сборки видео.
            Ускоряет сборку видео. Рекомендуется.

         * **ЗаписьВидеоОтключитьМасштабированиеШаговПоВремени {disablescalingofsteps}**:
            Отключает масштабирование видео фрагментов по времени.

         * **ЗаписьВидеоОтключитьСлайдСЗаголовкомФичи {turnofffeaturetitleslide}**:
            Отключает создание в видео начального слайда, в котором указывается название фича файла.

         * **ЗаписьВидеоОтключитьСлайдСценария {turnoffscenarioslide}**:
            Отключает создание в видео слайда, в котором выводится название сценария.

         * **ЗаписьВидеоОтключитьСлайдФинал {turnofffinalslide}**:
            Отключает создание в видео финального слайда, в котором выводится итоговая информация по видео.

         * **ЗаписьВидеоПодсвечиватьНажатияМышки {highlightmouseclicks}**:
            Включает подсветку кликов мышки. Используется утилита из проекта UIToolsFor1C.
            Эмуляция кликов мышки осуществляется с помощью SikuliX.

         * **ЗаписьВидеоЭмулироватьВводСКлавиатуры {emulatekeyboardinput}**:
            Включает ввод эмуляцию ввода текста с клавиатуры с помощью утилиты из проекта UIToolsFor1C.
            Допускается ввод текста только на русском и английском языках.
            Переключение раскладки клавиатуры осуществляется с помощью эмуляции нажатия Ctrl+Shift.

      *  Настройки  слайда с заголовком фичи

            * **ЗаписьВидеоЗаменитьСлайдЗаголовок {changefeaturetitleslide}**:
               Если флаг установлен, то стандартный файл с заголовком фичи будет заменен на указанный видео файл. Видео файл должен быть того разрешения, что и записываемое видео. Также у него должна быть аудио дорожка.

            * **ЗаписьВидеоДобавитьМузыкуКСлайдуЗаголовок {addmusictofeaturetitleslide}**:
               Если флаг установлен, то к видео файлу с заголовком фичи будет добавлена музыка.

            * **ЗаписьВидеоПутьКСлайдуЗаголовок {featuretitleslidepath}**:
               Путь к видео файлу с заголовком фичи,  который будет добавлен вместо стандартного.

      *  Настройки финального слайда

            * **ЗаписьВидеоЗаменитьСлайдФинал {changefinalslide}**:
               Если флаг установлен, то стандартный финальный файл будет заменен на указанный видео файл. Видео файл должен быть того разрешения, что и записываемое видео. Также у него должна быть аудио дорожка.

            * **ЗаписьВидеоДобавитьМузыкуКСлайдуФинал {addmusictofinalslide}**:
               Если флаг установлен, то к финальному видео файлу  будет добавлена музыка.

            * **ЗаписьВидеоПутьКСлайдуФинал {finalslidepath}**:
               Путь к финальному видео файлу, который будет добавлен вместо стандартного финального видео файла.

*  SikuliX server (устаревшее)

      * **ИспользоватьSikuliXСервер {usesikulixserver}**:
         SikuliX это Java приложение, которое позволяет управлять перемещением и нажатиями мыши на экране, а также эмулировать нажатие кнопок клавиатуры.
         SikuliX Server - это специальная программная оптимизация работы с SikuliX. Если опция включена VA собирает один большой скрипт из множества скриптов SikuliX, который можно запустить один раз и быстро выполнять необходимые команды, которые раньше приходилось запускать по одной.  Это позволяет существенно сэкономить время на выполнение одного скрипта SikuliX, т.к. не тратится время на запуск SikuliX и его выгрузку из памяти.
         Описание установки и настройки SikuliX и SikuliX Server приведено в разделе справки 20.1
         Открыть справку

      * **ЗаписьВидеоЭмулироватьДвиженияМышкиSikuliX {emulatemousemovement}**:
         Если флаг установлен, то при выполнении шагов будет выполняться попытка найти элемент формы или элемент управления на экране и переместить курсор мышки к нему.
         Для поиска картинки и передвижения мышки используется SikuliX. Картинка для поиска будет сгенерирована по тексту, полученному из элемента формы.
         Чтобы отключить движение мышки у конкретного шага надо использовать директиву #[DoNotMoveMouse].

      * **КаталогиСкриптовSikuliX {sikulixscriptpath}**:
         Каталог скриптов. Можно указывать несколько каталогов, разделенных через ";".

      * **КаталогДляГенерацииКартинок {pathforpicturegeneration}**:
         Каталог, в котором будут программно создаваться картинки для поиска их на экране.

## Vanessa Editor

   * **ИспользоватьДанныеТекущейФормыПриПодбореШагов {usecurrentformdatawhenselectingsteps}**:
      Включает возможность использовать данные текущей формы клиента тестирования, таких как имена полей, заголовков окон и так далее при подборе шагов.

   * **ПоказыватьСтрокиПодсценариевVanessaEditor {showsubscenariolines}**:
      Включает отображение строк подсценариев в редакторе.

   * **ПоказыватьМиниатюруКода {showcodeminiature}**:
      Управляет отображением миниатюры кода.

   * **ЗаменятьТабыНаПробелы {replacetabswithspaces}**:
      Опция определяет надо ли заменять в редакторе символы табуляции на пробелы.

   * **ОтображатьЗакладкиСверху {showbookmarkstop}**:
      Если опция установлена, то закладки будут отображаться сверху. Это нужно, чтобы предоставить редактору сценария больше места для отображения сценария.

   * **ПроверкаСинтаксисаВРедакторе {syntaxcheckingineditor}**:
      Опция для включения/отключения проверки синтаксиса в редакторе сценариев

   * **ПоказыватьРазличияВРедактореОтдельно {showdifferencesineditorseparately}**:
      Управляет режимом отображения различий при сравнении файлов в редакторе.
      Если опция включена - то отображается два столбца, иначе различия показываются в тексте файла.

   * **ОткрыватьНачальнуюСтраницуПриЗапуске {OpenStartPageAtStartup}**:
      Включает отображение начальной страницы в редакторе при запуске Vanessa Automation.

   * **ПоказыватьЗначенияПеременныхВСтрокахРедактора {ShowVariableValuesInEditorLines}**:
      Включает отображение в редакторе данных по значениям переменных (inline debug). Значения переменных обновляются после того как строка шага выполнена.

   * **ПриНажатииЭскейпВРедактореЗакрытьФорму {OnClickingEscapeInTheEditorCloseTheForm}**:
      Если при работе в редакторе была нажата клавиша Esc, то это вызовет событие закрытия формы Vanessa Automation.

   * **ОтображениеТабуляцииИПробелов {displayingtabsandspaces}**:
      Изменяет режим отображения табуляции и пробелов

   * **ТемаРедактораVanessaEditor {vanessaeditortheme}**:
      Позволяет сменить тему редактора.

## Библиотеки

*  Библиотеки повторного кода

      * **КаталогиБиблиотек {librarycatalogs}**:
         Список каталогов, в которых находятся epf файлы, содержащие шаги для сценариев и feature файлы, содержащие экспортные сценарии.

      * **МетаданныеБиблиотек {stepsfrommetadata}**:
         В списке указываются пути к формам внутри конфигурации, содержащим описания шагов.

## Клиенты тестирования

   * **ДанныеКлиентовТестирования {datatestclients}**:
      Список клиентов тестирования, в котором указаны:
           1. Имя профиля
           2. Синоним
           3. Тип клиента тестирования
           4. Строка подключения к базе
           5. Дополнительные параметры запуска
           6. Имя компьютера для установления подключения
           7. Порт

