# Тестирование мобильного клиента

Скачать adb[https://dl.google.com/android/repository/platform-tools-latest-windows.zip], и указать или в PATH путь к папке где лежит adb, или в ванессе указать прямой путь к папке adb на вкладке Сервис - Настройки тест клиента

Убедиться что есть установленные драйвера на устройство или универсальные USB драйвера [https://dl.google.com/android/repository/usb_driver_r13-windows.zip]
    1. Скачать и распаковать
    2. Правой кнопкой на файле android_winusb.inf - Установить

Включить на телефоне режим разработчика (читайте отдельно в инете на каждую модель)

Зайти в настройки разработчика и включить режим отладки

Есть несколько вариантов отладки:

1. Мы подключем телефон по USB, еслидрайвера стоят и все ок, то на телефоне появится сообщение о подтверждении соединения, вы соглашаетесь, и все.
2. Отладка по WiFi - почитать тут [https://developer.android.com/studio/command-line/adb#wireless]
В двух словах - включаете отладку по WiFi (это отдельная опция), потом на телефоне тыкаете опцию "Подключить устройство через код", и в консоле пишите:

```cmd
adb.exe: usage: adb pair HOST[:PORT] [PAIRING CODE]

C:\>adb pair 192.168.31.76:42045 751026

Successfully paired to 192.168.31.76:42045 [guid=adb-34775bc5-qrMXRU]
```

Если в конце было такое уведомление - то все отлично.

## Проверка тест клиента

Надо убедиться, что система видит ваше устройство, и что оно только одно, для этого ищем кнопку:
```Сервис - Настройки тест клиента - Настройки мобильного клиента - Проверить```
Нажимаем, у нас несколько вариантов:

1. ```Ошибка! Возможно не найдена программа adb. Установите ее, или пропишите к ней путь.```

Говорит о том, что не найдена программа adb, или путь к ней написан с ошибкой. Убедитесть что adb работает в cmd.
2. ```Не найдено подключенных устройств!```
Значит в системе не найдено ни одного устройства, которое готово к тесту. Проверка выполяется командой:
```adb devices```
Если там пусто - будет ошибка

3. ```Тест пройден```
Все отлично. Можно двигаться дальше.

На вкладке тест клиентов - указываем, что мы хотим запустить мобильный клиент. Настройки точно такие же, как и у веб клиента.

Нажимаем подключиться, и система выполнит три команды:

1. Убить текущий запущенный 1С
2. Запустить новый процесс 1С
3. Запустить базу данных с параметрами
(2 шаг - не обязательный, но практика показывает, что без него - может не сработать третий шаг)

## Особенности

1. Имя при каждом запуске будет сгенерировано с нуля, это особенность мобильной. Иначе - она просто падает в крит.
2. Не работает в SQL базах. Не удалось запустить, просто не подключается тест клиент.
3. Тестировалось на 8.3.19.1264 и 8.3.19.56. Это важно, так как в предыдущих версиях есть баги в платформе, и там валятся всякие разные ошибки с активацией окон.

# Тест мобильного приложения

Последовательность действий:

1. Публикуем базу менеджера (обычная веб публикация) - ```http:\\192.168.31.251\Manager```
2. Публикуем мобильную конфу - ```http:\\192.168.31.251\MobileConf```
3. Подключаем новую конфу в мобильной базе, та что по пути: ```http:\\192.168.31.251\MobileConf``` и даем ей некоторое имя ```MobileBaseName```
4. Добавляем в VA новый тест клиент
5. В поле пути базы пишем ```http:\\192.168.31.251\Manager``` Т.е. толкьо адрес, больше ничего, и слеши именно такие.
6. В поле имя базы на мобильной клиенте пишем ```MobileBaseName```
7. После этого выполняем подключение, все должно быть ок.

## Особенности

1. Текущая разработка выполнялась на 8.3.20.1613 и 8.3.20.40.
2. Не работает на SQL базах.
3. Не работает порт, отличный от стандартного
4. Не работает, если в базе есть пользователи, не важно - есть пароль или нету.
5. Так как тест клиент и менеджер - две разные базы, значит шаги, которые работают в менеджере тестирования - работать не будут, учтите это.
