﻿# language: ru


@IgnoreOn82Builds
@IgnoreOnOFBuilds
@IgnoreOnWeb



Функционал: Проверка парсера Gherkin VanessaExt


Контекст: 
	Дано Я запускаю сценарий открытия TestClient или подключаю уже существующий
	Когда Я открываю VanessaAutomation в режиме TestClient со стандартной библиотекой


// https://github.com/Pr-Mex/vanessa-automation/issues/2047
Сценарий: Некорректное выполнение условия в контексте при отсутствии шагов в самом сценарии
	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\СценарийБезШагов"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"
				
		Тогда таблица 'ДеревоТестов' стала равной:
			| "Наименование"                                        | "Статус"  |
			| "СценарийБезШагов.feature"                            | ""        |
			| "СценарийБезШагов"                                    | ""        |
			| "Контекст"                                            | ""        |
			| "Если существует переменная \"ИмяПеременной1\" Тогда" | "Success" |
			| "И я вывожу значение переменной \"ИмяПеременной1\""   | ""        |
			| "СценарийБезШагов1"                                   | ""        |
			| "СценарийБезШагов2"                                   | "Success" |
			| "И Пауза 1"                                           | "Success" |
		
				
		
				



Сценарий: Пустая группа в фиче. Новый парсер.
	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ПустаяГруппа"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"
				
		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'               |
			| 'ПустаяГруппа.feature'       |
			| 'ПередачаЧисловогоПараметра' |
			| 'ПередачаЧисловогоПараметра' |
			| '* Группа 1'                 |
			| 'И пауза 1'                  |
			| '*'                          |
			| 'И пауза 1'                  |
			| '* Группа 1'                 |
			| 'И пауза 1'                  |
		
				
				




Сценарий: Структура сценария использует подсценарий
	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\СтруктураСценарияИспользуетПодсценарий"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"
				
		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                                                     |
			| 'СтруктураСценарияИспользуетПодсценарий.feature'                                   |
			| 'Проверка секции контекст'                                                         |
			| 'Структура сценария использует подсценарий'                                        |
			| 'И я вызываю подсценарий без параметров структура сценария использует подсценарий' |
			| 'И пауза 1'                                                                        |
			| 'Примеры'                                                                          |
			| '\|\'Перем_Параметра\'          \|'                                                |
			| '\|\'ЗначениеПараметра1\'       \|'                                                |
			| 'И я вызываю подсценарий без параметров структура сценария использует подсценарий' |
			| 'И пауза 1'                                                                        |
			| '\|\'ЗначениеПараметра2\'       \|'                                                |
			| 'И я вызываю подсценарий без параметров структура сценария использует подсценарий' |
			| 'И пауза 1'                                                                        |
		
				



Сценарий: Передача числового параметра в подсценарий Новый парсер
	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ПередачаЧисловогоПараметра"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"
				
		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                               |
			| 'ПередачаЧисловогоПараметра.feature'         |
			| 'ПередачаЧисловогоПараметра'                 |
			| 'ПередачаЧисловогоПараметра'                 |
			| 'И Передача числового параметра экспорт 200' |
			| 'И пауза 200'                                |
		
				




Сценарий: Загрузка каталога фич

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'

		И я перехожу к закладке с именем "ГруппаСлужебная"
		И в поле с именем 'КаталогФичСлужебный' я ввожу текст "$КаталогИнструментов$\features\Core\Allure"
		И я перехожу к следующему реквизиту
				
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		

	* Проверка результата	
		И я нажимаю на кнопку с именем 'ФормаРазвернутьВсеСтрокиДереваСлужебный'
		И я выбираю пункт контекстного меню с именем 'ДеревоТестовКонтекстноеМенюСвернутьДоФич' на элементе формы с именем "ДеревоТестов"
		И Пауза 1
		Тогда в таблице "ДеревоТестов" количество строк "больше" 0
		
				


Сценарий: Чтение фичи на английском

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "VanessaExt\VanessaExt02"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		

	* Проверка результата	
		И я нажимаю на кнопку с именем 'ФормаРазвернутьВсеСтрокиДереваСлужебный'
				
		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                        | 'Статус'  |
			| 'VanessaExt02.feature'                                | ''        |
			| 'TestAddInParserEn'                                   | ''        |
			| 'TestAddInParserEn'                                   | 'Success' |
			| 'And 1C:Enterprise language expression "1=1" is true' | 'Success' |
		
				
		



Сценарий: Передача параметра во вложенный сценарий так, чтобы происходила передача параметра внутрь параметра в квадратрых скобках. Новый парсер.

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "Подсценарии\ПараметрВнтуриПараметра01"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		

	* Проверка результата	
		И я нажимаю на кнопку с именем 'ФормаРазвернутьВсеСтрокиДереваСлужебный'
				
		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                                                                     |
			| 'ПараметрВнтуриПараметра01.feature'                                                                |
			| 'ПараметрВнтуриПараметра01'                                                                        |
			| 'ПараметрВнтуриПараметра01 "Парам01"'                                                              |
			| 'И Экспортный сценарий для проверки передачи параметров внрутрь параметров "Значение01"'           |
			| 'И шаг с составным параметром "ЧастьПараметраЗначение01"'                                          |
			| 'И шаг с составным параметром \'ЧастьПараметраЗначение01\''                                        |
			| 'И шаг с составным параметром \'ЧастьПараметраЗначение01ВтораяЧастьПараметра\''                    |
			| 'И шаг с составным параметром \'ЧастьПараметраЗначение01ВтораяЧастьПараметраЗначение01\''          |
			| 'И шаг с составным параметром "ЧастьПараметраЗначение01ВтораяЧастьПараметраЗначение01ТретьяЧасть"' |
			| 'И шаг с составным параметром \'ЧастьПараметраЗначение01ВтораяЧастьПараметра[НетПараметра]\''      |
		
				


Сценарий: Проверка загрузки простой фичи на en

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\Фича_en_01"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		

	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"


		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                           | 'Статус'  |
			| 'Фича_en_01.feature'                                     | ''        |
			| 'Фича_en_01'                                             | ''        |
			| 'Background'                                             | ''        |
			| 'If "ИмяПеременнойКонтекст" variable exists Then'        | 'Success' |
			| 'And I delete "ИмяПеременнойКонтекст" variable'          | 'Success' |
			| 'And I save "2" in "$$ИмяПеременнойКонтекст$$" variable' | 'Success' |
			| 'Else'                                                   | ''        |
			| 'And I save "1" in "$$ИмяПеременнойКонтекст$$" variable' | 'Success' |
			| 'And I display "ИмяПеременнойКонтекст" variable value'   | 'Success' |
			| 'Scen_en_01'                                             | 'Success' |
			| 'And I save "2" in "ИмяПеременной2" variable'            | 'Success' |
			| 'And I display "ИмяПеременной2"   variable value'        | 'Success' |
			| 'Scen_en_02'                                             | 'Success' |
			| 'And I save "3" in "ИмяПеременной3" variable'            | 'Success' |
			| 'And I display "ИмяПеременной3"   variable value'        | 'Success' |
		
		
				
		Тогда в логе сообщений TestClient есть строки:
			| 'ИмяПеременнойКонтекст = 1' |
			| 'ИмяПеременной2 = 2'        |
			| 'ИмяПеременнойКонтекст = 2' |
			| 'ИмяПеременной3 = 3'        |
				



Сценарий: Проверка структур сценария. Вызов экспортной структуры сценария как есть.

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\СтруктураСценарияПередачаТаблиц02"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient

		// Проверка работы кнопки "Перезагрузить и выполнить" при включенном новом парсере
		И я нажимаю на кнопку с именем 'ФормаПерезагрузитьИВыполнить'
		И у элемента с именем 'ФлагСценарииВыполнены' я жду значения 'Да' в течение 60 секунд
				
		

	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"

		Тогда в логе сообщений TestClient есть строки:
			|'Перем1 = 1'|
			|'Перем3 = 3'|
			|'Колонка1 = Перем1'|
			|'Колонка2 = Значение22'|
			|'Колонка1 = Перем3'|
			|'Колонка2 = Значение44'|
			|'Перем2 = 11'|
			|'Перем4 = 33'|
			|'Колонка1 = Перем2'|
			|'Колонка2 = Значение22'|
			|'Колонка1 = Перем4'|
			|'Колонка2 = Значение44'|
		

		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                                               | 'Статус'  |
			| 'СтруктураСценарияПередачаТаблиц02.feature'                                  | ''        |
			| 'Проверка структуры сценария. Вызов экспортной структуры сценария как есть.' | ''        |
			| 'Проверка структуры сценария. Вызов экспортной структуры сценария как есть.' | 'Success' |
			| 'И Экспортная структура сценария с подсценарием'                             | ''        |
			| 'И Я запоминаю значение выражения <Парам1> в переменную <Парам2>'            | ''        |
			| 'И я вывожу значение переменной <Парам2>'                                    | ''        |
			| 'И Я запоминаю значение выражения <Парам3> в переменную <Парам4>'            | ''        |
			| 'И я вывожу значение переменной <Парам4>'                                    | ''        |
			| 'И Этот сценарий принимает одну таблицу Gherkin'                             | ''        |
			| '\|\'Колонка1\'\|\'Колонка2\'  \|'                                           | ''        |
			| '\|<Парам2>   \|\'Значение22\'\|'                                            | ''        |
			| '\|<Парам4>   \|\'Значение44\'\|'                                            | ''        |
			| 'И для каждой строки таблицы я выполняю'                                     | ''        |
			| '\|\'Колонка1\'\|\'Колонка2\'  \|'                                           | ''        |
			| '\|<Парам2>   \|\'Значение22\'\|'                                            | ''        |
			| '\|<Парам4>   \|\'Значение44\'\|'                                            | ''        |
			| 'И я вывожу значение переменной "Колонка1"'                                  | ''        |
			| 'И я вывожу значение переменной "Колонка2"'                                  | ''        |
			| 'Примеры'                                                                    | ''        |
			| '\|Парам1\| Парам2     \| Парам3 \| Парам4    \|'                            | ''        |
			| '\|\'1\'   \| \'Перем1\'  \| \'3\'   \| \'Перем3\'  \|'                      | ''        |
			| 'И Я запоминаю значение выражения \'1\' в переменную \'Перем1\''             | 'Success' |
			| 'И я вывожу значение переменной \'Перем1\''                                  | 'Success' |
			| 'И Я запоминаю значение выражения \'3\' в переменную \'Перем3\''             | 'Success' |
			| 'И я вывожу значение переменной \'Перем3\''                                  | 'Success' |
			| 'И Этот сценарий принимает одну таблицу Gherkin'                             | ''        |
			| '\|\'Колонка1\'\|\'Колонка2\'  \|'                                           | ''        |
			| '\|<Парам2>   \|\'Значение22\'\|'                                            | ''        |
			| '\|<Парам4>   \|\'Значение44\'\|'                                            | ''        |
			| 'И для каждой строки таблицы я выполняю'                                     | 'Success' |
			| '\|\'Колонка1\'\|\'Колонка2\'  \|'                                           | ''        |
			| '\|<Парам2>   \|\'Значение22\'\|'                                            | ''        |
			| '\|<Парам4>   \|\'Значение44\'\|'                                            | ''        |
			| 'И я вывожу значение переменной "Колонка1"'                                  | 'Success' |
			| 'И я вывожу значение переменной "Колонка2"'                                  | 'Success' |
			| '\|\'11\'  \| \'Перем2\'  \| \'33\'  \| \'Перем4\'  \|'                      | ''        |
			| 'И Я запоминаю значение выражения \'11\' в переменную \'Перем2\''            | 'Success' |
			| 'И я вывожу значение переменной \'Перем2\''                                  | 'Success' |
			| 'И Я запоминаю значение выражения \'33\' в переменную \'Перем4\''            | 'Success' |
			| 'И я вывожу значение переменной \'Перем4\''                                  | 'Success' |
			| 'И Этот сценарий принимает одну таблицу Gherkin'                             | ''        |
			| '\|\'Колонка1\'\|\'Колонка2\'  \|'                                           | ''        |
			| '\|<Парам2>   \|\'Значение22\'\|'                                            | ''        |
			| '\|<Парам4>   \|\'Значение44\'\|'                                            | ''        |
			| 'И для каждой строки таблицы я выполняю'                                     | 'Success' |
			| '\|\'Колонка1\'\|\'Колонка2\'  \|'                                           | ''        |
			| '\|<Парам2>   \|\'Значение22\'\|'                                            | ''        |
			| '\|<Парам4>   \|\'Значение44\'\|'                                            | ''        |
			| 'И я вывожу значение переменной "Колонка1"'                                  | 'Success' |
			| 'И я вывожу значение переменной "Колонка2"'                                  | 'Success' |
		
				
		
		


Сценарий: Проверка структур сценария. Передача таблиц. Замена таблицы структуры сценария.

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\СтруктураСценарияПередачаТаблиц01"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		

	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"

		Тогда в логе сообщений TestClient есть строки:
			|'Перем1 = 10'|
			|'Перем3 = 30'|
			|'Перем2 = 110'|
			|'Перем4 = 330'|


		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                                                     | 'Статус'  |
			| 'СтруктураСценарияПередачаТаблиц01.feature'                                        | ''        |
			| 'Проверка структуры сценария. Передача таблиц. Замена таблицы структуры сценария.' | ''        |
			| 'Проверка структуры сценария. Передача таблиц. Замена таблицы структуры сценария.' | 'Success' |
			| 'И Экспортная структура сценария простая'                                          | ''        |
			| '\|Парам1\| Парам2    \| Парам3\| Парам4\|'                                        | ''        |
			| '\|\'10\'  \| \'Перем1\'  \| \'30\'   \| \'Перем3\'  \|'                           | ''        |
			| '\|\'110\' \| \'Перем2\'  \| \'330\'  \| \'Перем4\'  \|'                           | ''        |
			| 'И Я запоминаю значение выражения <Парам1> в переменную <Парам2>'                  | ''        |
			| 'И я вывожу значение переменной <Парам2>'                                          | ''        |
			| 'И Я запоминаю значение выражения <Парам3> в переменную <Парам4>'                  | ''        |
			| 'И я вывожу значение переменной <Парам4>'                                          | ''        |
			| 'Примеры'                                                                          | ''        |
			| '\|Парам1\| Парам2    \| Парам3\| Парам4\|'                                        | ''        |
			| '\|\'10\'  \| \'Перем1\'  \| \'30\'   \| \'Перем3\'  \|'                           | ''        |
			| 'И Я запоминаю значение выражения \'10\' в переменную \'Перем1\''                  | 'Success' |
			| 'И я вывожу значение переменной \'Перем1\''                                        | 'Success' |
			| 'И Я запоминаю значение выражения \'30\' в переменную \'Перем3\''                  | 'Success' |
			| 'И я вывожу значение переменной \'Перем3\''                                        | 'Success' |
			| '\|\'110\' \| \'Перем2\'  \| \'330\'  \| \'Перем4\'  \|'                           | ''        |
			| 'И Я запоминаю значение выражения \'110\' в переменную \'Перем2\''                 | 'Success' |
			| 'И я вывожу значение переменной \'Перем2\''                                        | 'Success' |
			| 'И Я запоминаю значение выражения \'330\' в переменную \'Перем4\''                 | 'Success' |
			| 'И я вывожу значение переменной \'Перем4\''                                        | 'Success' |
		
				
		
						


Сценарий: Проверка структур сценария. Простая загрузка.

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\СтруктураСценарияПростаяЗагрузка"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		

	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"

		
		Тогда в логе сообщений TestClient есть строки:
			|'Перем1 = 1'|
			|'Перем3 = 3'|
			|'Перем2 = 11'|
			|'Перем4 = 33'|
		


		
		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                                    | 'Статус'  |
			| 'СтруктураСценарияПростаяЗагрузка.feature'                        | ''        |
			| 'Проверка структуры сценария простая загрузка'                    | ''        |
			| 'Проверка структуры сценария простая загрузка'                    | ''        |
			| 'И Я запоминаю значение выражения <Парам1> в переменную <Парам2>' | ''        |
			| 'И я вывожу значение переменной <Парам2>'                         | ''        |
			| 'И Я запоминаю значение выражения <Парам3> в переменную <Парам4>' | ''        |
			| 'И я вывожу значение переменной <Парам4>'                         | ''        |
			| 'Примеры'                                                         | ''        |
			| '\|Парам1\| Парам2    \| Парам3\| Парам4\|'                       | ''        |
			| '\|\'1\'  \| \'Перем1\'  \| \'3\'   \| \'Перем3\'  \|'            | 'Success' |
			| 'И Я запоминаю значение выражения \'1\' в переменную \'Перем1\''  | 'Success' |
			| 'И я вывожу значение переменной \'Перем1\''                       | 'Success' |
			| 'И Я запоминаю значение выражения \'3\' в переменную \'Перем3\''  | 'Success' |
			| 'И я вывожу значение переменной \'Перем3\''                       | 'Success' |
			| '\|\'11\' \| \'Перем2\'  \| \'33\'  \| \'Перем4\'  \|'            | 'Success' |
			| 'И Я запоминаю значение выражения \'11\' в переменную \'Перем2\'' | 'Success' |
			| 'И я вывожу значение переменной \'Перем2\''                       | 'Success' |
			| 'И Я запоминаю значение выражения \'33\' в переменную \'Перем4\'' | 'Success' |
			| 'И я вывожу значение переменной \'Перем4\''                       | 'Success' |
		
		

Сценарий: Передача многострочных строк в подсценарии несколько штук

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\МногострочныеСтрокиПодсценарииНесколько"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		

	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"

		Тогда в логе сообщений TestClient есть строки:
			|'Первая строка 1'|
			|'Вторая строка 2'|
			|'Третья строка 3'|
			|'Первая строка 11'|
			|'Вторая строка 22'|
			|'Третья строка 33'|
			|'Первая строка 111'|
			|'Вторая строка 222'|
			|'Третья строка 333'|
				


Сценарий: Передача многострочных строк в подсценарии

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\МногострочныеСтрокиПодсценарии"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"

		Тогда в логе сообщений TestClient есть строки:
			|'Первая строка 1'|
			|'Вторая строка 2'|
			|'Третья строка 3'|






Сценарий: Экранирование спецсимволов

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ЭкранированиеСпецсимволов"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"


		Тогда в логе сообщений TestClient есть строки:
			|'ИмяПеременной = qqq\ggg'|
			|'ИмяПеременной = qqq\rggg'|
			|'ИмяПеременной = qqq\nggg'|
			|'ИмяПеременной = qqq\|ggg'|
			|'ИмяПеременной = "qqq"ggg"'|
			|'ИмяПеременной = qqq\'ggg'|
			|'Колонка1 = qqq\ggg'|
			|'Колонка1 = qqq\rggg'|
			|'Колонка1 = qqq\nggg'|
			|'Колонка1 = qqq\|ggg'|
			|'Колонка1 = qqq"ggg'|
			|'Колонка1 = qqq\'ggg'|
			

Сценарий: Передача таблиц в подсценарии. Передача двух из четырёх таблиц.

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ПередачаНесколькихТаблиц2из4"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"

		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                            | 'Статус'  |
			| 'ПередачаНесколькихТаблиц2из4.feature'                    | ''        |
			| 'Передача таблиц в подсценарии. Несколько таблиц. 2 из 4' | ''        |
			| 'Передача таблиц в подсценарии. Несколько таблиц. 2 из 4' | 'Success' |
			| 'И Этот сценарий принимает четыре таблицы Gherkin'        | ''        |
			| '\|\'Колонка1\'\|\'Колонка2\'\|'                          | ''        |
			| '\|\'Значение11\'\|\'Значение22\'\|'                      | ''        |
			| '\|\'Значение33\'\|\'Значение44\'\|'                      | ''        |
			| '\|\'Значение55\'\|\'Значение66\'\|'                      | ''        |
			| ''                                                        | ''        |
			| '\|\|'                                                    | ''        |
			| ''                                                        | ''        |
			| '\| \|'                                                   | ''        |
			| ''                                                        | ''        |
			| '\|\'Колонка7\'\|\'Колонка8\'\|'                          | ''        |
			| '\|\'Значение11\'\|\'Значение22\'\|'                      | ''        |
			| '\|\'Значение33\'\|\'Значение44\'\|'                      | ''        |
			| 'И для каждой строки таблицы я выполняю'                  | 'Success' |
			| '\|\'Колонка1\'\|\'Колонка2\'\|'                          | ''        |
			| '\|\'Значение11\'\|\'Значение22\'\|'                      | ''        |
			| '\|\'Значение33\'\|\'Значение44\'\|'                      | ''        |
			| '\|\'Значение55\'\|\'Значение66\'\|'                      | ''        |
			| 'И я вывожу значение переменной "Колонка1"'               | 'Success' |
			| 'И я вывожу значение переменной "Колонка2"'               | 'Success' |
			| 'И для каждой строки таблицы я выполняю'                  | 'Success' |
			| '\|\'Колонка3\'\|\'Колонка4\'\|'                          | ''        |
			| '\|\'Значение1\'\|\'Значение2\'\|'                        | ''        |
			| '\|\'Значение3\'\|\'Значение4\'\|'                        | ''        |
			| 'И я вывожу значение переменной "Колонка3"'               | 'Success' |
			| 'И я вывожу значение переменной "Колонка4"'               | 'Success' |
			| 'И для каждой строки таблицы я выполняю'                  | 'Success' |
			| '\|\'Колонка5\'\|\'Колонка6\'\|'                          | ''        |
			| '\|\'Значение1\'\|\'Значение2\'\|'                        | ''        |
			| '\|\'Значение3\'\|\'Значение4\'\|'                        | ''        |
			| 'И я вывожу значение переменной "Колонка5"'               | 'Success' |
			| 'И я вывожу значение переменной "Колонка6"'               | 'Success' |
			| 'И для каждой строки таблицы я выполняю'                  | 'Success' |
			| '\|\'Колонка7\'\|\'Колонка8\'\|'                          | ''        |
			| '\|\'Значение11\'\|\'Значение22\'\|'                      | ''        |
			| '\|\'Значение33\'\|\'Значение44\'\|'                      | ''        |
			| 'И я вывожу значение переменной "Колонка7"'               | 'Success' |
			| 'И я вывожу значение переменной "Колонка8"'               | 'Success' |
		
		
		Тогда в логе сообщений TestClient есть строки:
			|'Колонка1 = Значение11'|
			|'Колонка2 = Значение22'|
			|'Колонка1 = Значение33'|
			|'Колонка2 = Значение44'|
			|'Колонка1 = Значение55'|
			|'Колонка2 = Значение66'|
			|'Колонка3 = Значение1'|
			|'Колонка4 = Значение2'|
			|'Колонка3 = Значение3'|
			|'Колонка4 = Значение4'|
			|'Колонка5 = Значение1'|
			|'Колонка6 = Значение2'|
			|'Колонка5 = Значение3'|
			|'Колонка6 = Значение4'|
			|'Колонка7 = Значение11'|
			|'Колонка8 = Значение22'|
			|'Колонка7 = Значение33'|
			|'Колонка8 = Значение44'|
		

Сценарий: Передача таблиц в подсценарии. Передача четрых таблиц.

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ПередачаНесколькихТаблиц"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"


		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                     | 'Статус'  |
			| 'ПередачаНесколькихТаблиц.feature'                 | ''        |
			| 'Передача таблиц в подсценарии. Несколько таблиц.' | ''        |
			| 'Передача таблиц в подсценарии. Несколько таблиц.' | 'Success' |
			| 'И Этот сценарий принимает четыре таблицы Gherkin' | ''        |
			| '\|\'Колонка1\'\|\'Колонка2\'\|'                   | ''        |
			| '\|\'Значение11\'\|\'Значение22\'\|'               | ''        |
			| '\|\'Значение33\'\|\'Значение44\'\|'               | ''        |
			| '\|\'Значение55\'\|\'Значение66\'\|'               | ''        |
			| ''                                                 | ''        |
			| '\|\'Колонка3\'\|\'Колонка4\'\|'                   | ''        |
			| '\|\'Значение11\'\|\'Значение22\'\|'               | ''        |
			| '\|\'Значение33\'\|\'Значение44\'\|'               | ''        |
			| '\|\'Значение55\'\|\'Значение66\'\|'               | ''        |
			| ''                                                 | ''        |
			| '\|\'Колонка5\'\|\'Колонка6\'\|'                   | ''        |
			| '\|\'Значение11\'\|\'Значение22\'\|'               | ''        |
			| '\|\'Значение33\'\|\'Значение44\'\|'               | ''        |
			| '\|\'Значение55\'\|\'Значение66\'\|'               | ''        |
			| ''                                                 | ''        |
			| '\|\'Колонка7\'\|\'Колонка8\'\|'                   | ''        |
			| '\|\'Значение11\'\|\'Значение22\'\|'               | ''        |
			| '\|\'Значение33\'\|\'Значение44\'\|'               | ''        |
			| 'И для каждой строки таблицы я выполняю'           | 'Success' |
			| '\|\'Колонка1\'\|\'Колонка2\'\|'                   | ''        |
			| '\|\'Значение11\'\|\'Значение22\'\|'               | ''        |
			| '\|\'Значение33\'\|\'Значение44\'\|'               | ''        |
			| '\|\'Значение55\'\|\'Значение66\'\|'               | ''        |
			| 'И я вывожу значение переменной "Колонка1"'        | 'Success' |
			| 'И я вывожу значение переменной "Колонка2"'        | 'Success' |
			| 'И для каждой строки таблицы я выполняю'           | 'Success' |
			| '\|\'Колонка3\'\|\'Колонка4\'\|'                   | ''        |
			| '\|\'Значение11\'\|\'Значение22\'\|'               | ''        |
			| '\|\'Значение33\'\|\'Значение44\'\|'               | ''        |
			| '\|\'Значение55\'\|\'Значение66\'\|'               | ''        |
			| 'И я вывожу значение переменной "Колонка3"'        | 'Success' |
			| 'И я вывожу значение переменной "Колонка4"'        | 'Success' |
			| 'И для каждой строки таблицы я выполняю'           | 'Success' |
			| '\|\'Колонка5\'\|\'Колонка6\'\|'                   | ''        |
			| '\|\'Значение11\'\|\'Значение22\'\|'               | ''        |
			| '\|\'Значение33\'\|\'Значение44\'\|'               | ''        |
			| '\|\'Значение55\'\|\'Значение66\'\|'               | ''        |
			| 'И я вывожу значение переменной "Колонка5"'        | 'Success' |
			| 'И я вывожу значение переменной "Колонка6"'        | 'Success' |
			| 'И для каждой строки таблицы я выполняю'           | 'Success' |
			| '\|\'Колонка7\'\|\'Колонка8\'\|'                   | ''        |
			| '\|\'Значение11\'\|\'Значение22\'\|'               | ''        |
			| '\|\'Значение33\'\|\'Значение44\'\|'               | ''        |
			| 'И я вывожу значение переменной "Колонка7"'        | 'Success' |
			| 'И я вывожу значение переменной "Колонка8"'        | 'Success' |
		
		
		
		Тогда в логе сообщений TestClient есть строки:
			|'Колонка1 = Значение11'|
			|'Колонка2 = Значение22'|
			|'Колонка1 = Значение33'|
			|'Колонка2 = Значение44'|
			|'Колонка1 = Значение55'|
			|'Колонка2 = Значение66'|
			|'Колонка3 = Значение11'|
			|'Колонка4 = Значение22'|
			|'Колонка3 = Значение33'|
			|'Колонка4 = Значение44'|
			|'Колонка3 = Значение55'|
			|'Колонка4 = Значение66'|
			|'Колонка5 = Значение11'|
			|'Колонка6 = Значение22'|
			|'Колонка5 = Значение33'|
			|'Колонка6 = Значение44'|
			|'Колонка5 = Значение55'|
			|'Колонка6 = Значение66'|
			|'Колонка7 = Значение11'|
			|'Колонка8 = Значение22'|
			|'Колонка7 = Значение33'|
			|'Колонка8 = Значение44'|
				


Сценарий: Передача таблиц в подсценарии. Передача одной таблицы.

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ПередачаТаблицВПодсценарииОднаТаблица"

		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"

		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                   | 'Статус'  |
			| 'ПередачаТаблицВПодсценарииОднаТаблица.feature'  | ''        |
			| 'Передача таблиц в подсценарии. Одна таблица.'   | ''        |
			| 'Передача таблиц в подсценарии. Одна таблица.'   | 'Success' |
			| 'И Этот сценарий принимает одну таблицу Gherkin' | ''        |
			| '\|\'Колонка1\'\|\'Колонка2\'\|'                 | ''        |
			| '\|\'Значение11\'\|\'Значение22\'\|'             | ''        |
			| '\|\'Значение33\'\|\'Значение44\'\|'             | ''        |
			| '\|\'Значение55\'\|\'Значение66\'\|'             | ''        |
			| 'И для каждой строки таблицы я выполняю'         | 'Success' |
			| '\|\'Колонка1\'\|\'Колонка2\'\|'                 | ''        |
			| '\|\'Значение11\'\|\'Значение22\'\|'             | ''        |
			| '\|\'Значение33\'\|\'Значение44\'\|'             | ''        |
			| '\|\'Значение55\'\|\'Значение66\'\|'             | ''        |
			| 'И я вывожу значение переменной "Колонка1"'      | 'Success' |
			| 'И я вывожу значение переменной "Колонка2"'      | 'Success' |
		
		
		Тогда в логе сообщений TestClient есть строки:
			|'Колонка1 = Значение11'|
			|'Колонка2 = Значение22'|
			|'Колонка1 = Значение33'|
			|'Колонка2 = Значение44'|
			|'Колонка1 = Значение55'|
			|'Колонка2 = Значение66'|
						



Сценарий: Секция контекст

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ПроверкаСекцииКонтекст"

		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"

		Тогда в логе сообщений TestClient есть строки:
			|'СчетчикСценариев = 0'|
			|'СчетчикСценариев = 1'|
			
		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                                                                          | 'Статус'  |
			| 'ПроверкаСекцииКонтекст.feature'                                                                        | ''        |
			| 'Проверка секции контекст'                                                                              | ''        |
			| 'Контекст'                                                                                              | ''        |
			| 'Если не существует переменная "СчетчикСценариев" Тогда'                                                | 'Success' |
			| 'И Я запоминаю значение выражения \'0\' в переменную "СчетчикСценариев" глобально'                      | 'Success' |
			| 'И я вывожу значение переменной "СчетчикСценариев"'                                                     | 'Success' |
			| 'Проверка секции контекст один'                                                                         | 'Success' |
			| 'И Я запоминаю значение выражения \'$$СчетчикСценариев$$+1\' в переменную "СчетчикСценариев" глобально' | 'Success' |
			| 'И Я запоминаю значение выражения \'2\' в переменную "ИмяПеременной2"'                                  | 'Success' |
			| 'И я вывожу значение переменной "ИмяПеременной2"'                                                       | 'Success' |
			| 'Проверка секции контекст два'                                                                          | 'Success' |
			| 'И Я запоминаю значение выражения \'$$СчетчикСценариев$$+1\' в переменную "СчетчикСценариев" глобально' | 'Success' |
			| 'И Я запоминаю значение выражения \'3\' в переменную "ИмяПеременной3"'                                  | 'Success' |
			| 'И я вывожу значение переменной "ИмяПеременной3"'                                                       | 'Success' |
		
				

Сценарий: Многострочные параметры. Передача таблиц и многострочных параметров в один шаг. Таблицы должны идти позже.

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ПроверкаМногострочныхПараметров02"

		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"

		Тогда в логе сообщений TestClient есть строки:
			|'Строка1\nСтрока2'|
			|'Колонка1'|
			|'Строка3\nСтрока4'|
			|'Колонка2'|
			
		



Сценарий: Многострочные параметры

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ПроверкаМногострочныхПараметров01"

		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"

		Тогда в логе сообщений TestClient есть строки:
			|'Первая строка'|
			|'Вторая строка'|
			|'Третья строка'|
		

Сценарий: Проверка попытки исключения

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ПроверкаПопыткиИсключения"

		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"

		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                                         | 'Статус'  |
			| 'ПроверкаПопыткиИсключения.feature'                                    | ''        |
			| 'Проверка попытки исключения'                                          | ''        |
			| 'Проверка попытки исключения'                                          | 'Success' |
			| 'Попытка'                                                              | ''        |
			| 'И Я запоминаю значение выражения \'1\' в переменную "ИмяПеременной1"' | 'Success' |
			| 'Тогда я вызываю исключение "Текст исключения"'                        | 'Broken'  |
			| 'И Я запоминаю значение выражения \'2\' в переменную "ИмяПеременной2"' | ''        |
			| 'Исключение'                                                           | ''        |
			| 'И Я запоминаю значение выражения \'3\' в переменную "ИмяПеременной3"' | 'Success' |
			| 'Попытка'                                                              | ''        |
			| 'И Я запоминаю значение выражения \'1\' в переменную "ИмяПеременной1"' | 'Success' |
			| 'И Я запоминаю значение выражения \'2\' в переменную "ИмяПеременной2"' | 'Success' |
			| 'Исключение'                                                           | ''        |
			| 'И Я запоминаю значение выражения \'3\' в переменную "ИмяПеременной3"' | ''        |
			| 'И Я запоминаю значение выражения \'4\' в переменную "ИмяПеременной4"' | 'Success' |
		
				
		И элемент формы с именем "Статистика" стал равен '1/1/7, 5/0/0'
				


Сценарий: Проверка работы цикла

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ПроверкаРаботыЦикла"
		
		
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"

		
		Тогда в логе сообщений TestClient есть строки:
			|'Колонка1 = Значение1'|
			|'Колонка2 = Значение2'|
			|'Колонка1 = Значение3'|
			|'Колонка2 = Значение4'|
				


		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                              | 'Статус'  |
			| 'ПроверкаРаботыЦикла.feature'               | ''        |
			| 'Проверка работы цикла'                     | ''        |
			| 'Проверка работы цикла'                     | 'Success' |
			| 'И для каждой строки таблицы я выполняю'    | 'Success' |
			| '\|\'Колонка1\'\|\'Колонка2\'\|'            | ''        |
			| '\|\'Значение1\'\|\'Значение2\'\|'          | ''        |
			| '\|\'Значение3\'\|\'Значение4\'\|'          | ''        |
			| 'И я вывожу значение переменной "Колонка1"' | 'Success' |
			| 'И я вывожу значение переменной "Колонка2"' | 'Success' |
		
						


Сценарий: Загрузка таблиц Gherkin

	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ТаблицаGherkin"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
		
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"


		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                  | 'Статус'  |
			| 'ТаблицаGherkin.feature'                        | ''        |
			| 'Таблица Gherkin'                               | ''        |
			| 'Сценарий таблица Gherkin'                      | 'Success' |
			| 'И шаг VA проверяющий тип параметров в таблице' | 'Success' |
			| '\|\'Колонка1\'\|\'Колонка2\' \|'               | ''        |
			| '\|\'Значение1\'\|\'Значение2\'\|'              | ''        |
			| ''                                              | ''        |
			| '\|\'Колонка3\'\|"Колонка4" \|'                 | ''        |
			| '\|  1       \|     2    \|'                    | ''        |
			| ''                                              | ''        |
			| '\|\'Колонка5\'\|\'Колонка6\' \|'               | ''        |
			| '\|  08.04.81\|  08.04.1981\|'                  | ''        |
		
				

		Тогда в логе сообщений TestClient есть строки:
			|'Колонка1, Тип=Строка'|
			|'Колонка2, Тип=Строка'|
			|'Значение1, Тип=Строка'|
			|'Значение2, Тип=Строка'|
			|'Колонка3, Тип=Строка'|
			|'Колонка4, Тип=Строка'|
			|'1, Тип=Число'|
			|'2, Тип=Число'|
			|'Колонка5, Тип=Строка'|
			|'Колонка6, Тип=Строка'|
				
				
		



Сценарий: Загрузка одной фичи с вызовом подсценариев
	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ЧтениеОднойФичиСПодсценарием"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			
		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"
				

		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                                             | 'Статус'  |
			| 'ЧтениеОднойФичиСПодсценарием.feature'                                     | ''        |
			| 'Чтение одной фичи с подсценарием.'                                        | ''        |
			| 'Чтение одной фичи с подсценарием.'                                        | 'Success' |
			| 'И я вызываю подсценарий один с параметрами "111" "222"'                   | ''        |
			| 'И Я запоминаю значение выражения \'1\' в переменную "111"'                | 'Success' |
			| 'И Я запоминаю значение выражения \'1\' в переменную "222"'                | 'Success' |
			| 'И Я вызываю подсценарий два с параметрами "111" "222"'                    | ''        |
			| 'И Я запоминаю значение выражения \'2\' в переменную "111"'                | 'Success' |
			| 'И Я запоминаю значение выражения \'2\' в переменную "222"'                | 'Success' |
			| 'И Я запоминаю значение выражения \'111\' в переменную "ИмяПеременной111"' | 'Success' |
			| 'И я вызываю подсценарий один с параметрами "111" "222"'                   | ''        |
			| 'И Я запоминаю значение выражения \'1\' в переменную "111"'                | 'Success' |
			| 'И Я запоминаю значение выражения \'1\' в переменную "222"'                | 'Success' |
			| 'И Я вызываю подсценарий два с параметрами "111" "222"'                    | ''        |
			| 'И Я запоминаю значение выражения \'2\' в переменную "111"'                | 'Success' |
			| 'И Я запоминаю значение выражения \'2\' в переменную "222"'                | 'Success' |
		
			
				
		





Сценарий: Загрузка одной фичи с группами шагов
	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ЧтениеОднойФичиГруппаШагов"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			

		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"
				
		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                                         | 'Статус'  |
			| 'ЧтениеОднойФичиГруппаШагов.feature'                                   | ''        |
			| 'Чтение одной фичи без своей epf. Группа шагов и условия.'             | ''        |
			| 'Чтение одной фичи без своей epf. Группа шагов и условия.'             | 'Success' |
			| 'И Я запоминаю значение выражения \'1\' в переменную "ИмяПеременной1"' | 'Success' |
			| '* Группа один'                                                        | ''        |
			| '* Группа два'                                                         | ''        |
			| 'И Я запоминаю значение выражения \'2\' в переменную "ИмяПеременной2"' | 'Success' |
			| 'И шаг VA проверяющий тип параметра 1 "Число"'                         | 'Success' |
			| '* Группа три'                                                         | ''        |
			| 'И шаг VA проверяющий тип параметра "1" "Строка"'                      | 'Success' |
			| 'И шаг VA проверяющий тип параметра 08.04.81 "Дата"'                   | 'Success' |
			| 'И шаг VA проверяющий тип параметра 08.04.1981 "Дата"'                 | 'Success' |
		
		И в таблице 'ДеревоТестов' я перехожу к первой строке
		И в таблице "ДеревоТестов" я сворачиваю строку:
			| 'Наименование' |
			| '* Группа два' |
		И в таблице "ДеревоТестов" я сворачиваю строку:
			| 'Наименование' |
			| '* Группа три' |

		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                                         | 'Статус'  |
			| 'ЧтениеОднойФичиГруппаШагов.feature'                                   | ''        |
			| 'Чтение одной фичи без своей epf. Группа шагов и условия.'             | ''        |
			| 'Чтение одной фичи без своей epf. Группа шагов и условия.'             | 'Success' |
			| 'И Я запоминаю значение выражения \'1\' в переменную "ИмяПеременной1"' | 'Success' |
			| '* Группа один'                                                        | ''        |
			| '* Группа два'                                                         | ''        |
			| 'И шаг VA проверяющий тип параметра 1 "Число"'                         | 'Success' |
			| '* Группа три'                                                         | ''        |
			| 'И шаг VA проверяющий тип параметра 08.04.81 "Дата"'                   | 'Success' |
			| 'И шаг VA проверяющий тип параметра 08.04.1981 "Дата"'                 | 'Success' |
		
								


Сценарий: Загрузка одной фичи с группами шагов и условиями
	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ЧтениеОднойФичиГруппаШаговИУсловия"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			

		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"
				
		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                                             | 'Статус'  |
			| 'ЧтениеОднойФичиГруппаШаговИУсловия.feature'                               | ''        |
			| 'Чтение одной фичи без своей epf. Группа шагов и условия.'                 | ''        |
			| 'Чтение одной фичи без своей epf. Группа шагов и условия. Тест2.2'         | 'Success' |
			| 'Если "Ложь" Тогда'                                                        | 'Success' |
			| 'И Я запоминаю значение выражения \'0\' в переменную "ИмяПеременной0"'     | ''        |
			| 'ИначеЕсли "Ложь" Тогда'                                                   | 'Success' |
			| 'И Я запоминаю значение выражения \'00\' в переменную "ИмяПеременной00"'   | ''        |
			| 'Иначе'                                                                    | ''        |
			| 'И Я запоминаю значение выражения \'000\' в переменную "ИмяПеременной000"' | 'Success' |
			| 'Если "Истина" Тогда'                                                      | 'Success' |
			| 'И Я запоминаю значение выражения \'0\' в переменную "ИмяПеременной0"'     | 'Success' |
			| 'ИначеЕсли "Ложь" Тогда'                                                   | ''        |
			| 'И Я запоминаю значение выражения \'00\' в переменную "ИмяПеременной00"'   | ''        |
			| 'Иначе'                                                                    | ''        |
			| 'И Я запоминаю значение выражения \'000\' в переменную "ИмяПеременной000"' | ''        |
			| 'Если "Ложь" Тогда'                                                        | 'Success' |
			| 'И Я запоминаю значение выражения \'0\' в переменную "ИмяПеременной0"'     | ''        |
			| 'ИначеЕсли "Истина" Тогда'                                                 | 'Success' |
			| 'И Я запоминаю значение выражения \'00\' в переменную "ИмяПеременной00"'   | 'Success' |
			| 'Иначе'                                                                    | ''        |
			| 'И Я запоминаю значение выражения \'000\' в переменную "ИмяПеременной000"' | ''        |
			| 'И Я запоминаю значение выражения \'1\' в переменную "ИмяПеременной1"'     | 'Success' |
			| '* Группа один'                                                            | ''        |
			| '* Группа два'                                                             | ''        |
			| 'И Я запоминаю значение выражения \'2\' в переменную "ИмяПеременной2"'     | 'Success' |
		
				
		



Сценарий: Загрузка одной фичи без своей epf
	* Загрузка тестовой фичи
		И я перехожу к закладке с именем "ГруппаСлужебная"
		Когда В поле с именем "КаталогФичСлужебный" я указываю путь к служебной фиче "ПарсерКомпонента\ЧтениеОднойФичи"
		
		И я перехожу к закладке с именем "ГруппаНастройки"
		И я устанавливаю флаг с именем 'ИспользоватьКомпонентуVanessaExt'
		И я устанавливаю флаг с именем 'ИспользоватьПарсерGherkinИзКомпонентыVanessaExt'
			

		И Я нажимаю на кнопку перезагрузить сценарии в Vanessa-Automation TestClient
		И Я нажимаю на кнопку выполнить сценарии в Vanessa-Automation TestClient
	
	* Проверка результата		
		И я перехожу к закладке с именем "ГруппаСлужебная"
		И я нажимаю на кнопку с именем 'РазвернутьВсеСтрокиДереваСлужебный'
		И я перехожу к закладке с именем "ГруппаЗапускТестов"
				
		Тогда таблица "ДеревоТестов" стала равной:
			| 'Наименование'                                                                      | 'Статус'  |
			| 'ЧтениеОднойФичи.feature'                                                           | ''        |
			| 'Чтение одной фичи без своей epf'                                                   | ''        |
			| 'Чтение одной фичи без своей epf. Сценарий один.'                                   | 'Success' |
			| 'И Я запоминаю значение выражения \'1\' в переменную "ИмяПеременной1"'              | 'Success' |
			| 'И Я запоминаю значение выражения \'2\' в переменную "ИмяПеременной2"'              | 'Success' |
			| 'И шаг VA проверяющий тип параметра 1 "Число"'                                      | 'Success' |
			| 'И шаг VA проверяющий тип параметра -1 "Число"'                                     | 'Success' |
			| 'И шаг VA проверяющий тип параметра -1.1 "Число"'                                   | 'Success' |
			| 'И шаг VA проверяющий тип параметра 1.1 "Число"'                                    | 'Success' |
			| 'И шаг VA проверяющий тип параметра "1" "Строка"'                                   | 'Success' |
			| 'И шаг VA проверяющий тип параметра 08.04.81 "Дата"'                                | 'Success' |
			| 'И шаг VA проверяющий тип параметра 08.04.1981 "Дата"'                              | 'Success' |
			| 'Чтение одной фичи без своей epf. Сценарий два.'                                    | 'Success' |
			| 'И Я запоминаю значение выражения \'3\' в переменную "ИмяПеременной3"'              | 'Success' |
			| 'И Я запоминаю значение выражения \'4\' в переменную "ИмяПеременной4"'              | 'Success' |
			| 'И Я запоминаю значение выражения \'"Стр1\Стр2"\' в переменную "ИмяПеременнойСтр1"' | 'Success' |
			| 'И я вывожу значение переменной "ИмяПеременнойСтр1"'                                | 'Success' |
		
		
		Тогда в логе сообщений TestClient есть строки:
			|'ИмяПеременнойСтр1 = Стр1\Стр2'|
		



