﻿//начало текста модуля

///////////////////////////////////////////////////
//Служебные функции и процедуры
///////////////////////////////////////////////////

&НаКлиенте
// контекст фреймворка Vanessa-Behavior
Перем Ванесса;
 
&НаКлиенте
// Структура, в которой хранится состояние сценария между выполнением шагов. Очищается перед выполнением каждого сценария.
Перем Контекст Экспорт;
 
&НаКлиенте
// Структура, в которой можно хранить служебные данные между запусками сценариев. Существует, пока открыта форма Vanessa-Behavior.
Перем КонтекстСохраняемый Экспорт;

// Делает отключение модуля
&НаКлиенте
Функция ОтключениеМодуля() Экспорт

	Ванесса = Неопределено;
	Контекст = Неопределено;
	КонтекстСохраняемый = Неопределено;

КонецФункции

&НаКлиенте
// Функция экспортирует список шагов, которые реализованы в данной внешней обработке.
Функция ПолучитьСписокТестов(КонтекстФреймворкаBDD) Экспорт
	Ванесса = КонтекстФреймворкаBDD;
	
	ВсеТесты = Новый Массив;

	//описание параметров
	//ДобавитьШагВМассивТестов(ВсеТесты,Снипет,ИмяПроцедуры,ПредставлениеТеста,Транзакция,Параметр);

	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯНажимаюНаКнопкуДиалогаВыбораФайлов()","ЯНажимаюНаКнопкуДиалогаВыбораФайлов","Когда Я нажимаю на кнопку диалога выбора файлов");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ВОткрывшемсяОкнеЯУказываюПутьКОбработкеVanessa_behaviorepf()","ВОткрывшемсяОкнеЯУказываюПутьКОбработкеVanessa_behaviorepf","И в открывшемся окне я указываю путь к обработке Vanessa-behavior.epf");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯНабираюТекст(Парам01)","ЯНабираюТекст","И я набираю текст ""текст""","Если включено использование компоненты VanessaExt, то эмулирует ввод клавиш клавиатуры с помощью компоненты.
		|Иначе эмулирует ввод текста с помощью утилиты KeyboardType (устарело). Возможен ввод на русском и английском языке. Для переключения расскладки эмулируется сочетание клавиш Ctrl+Shift.
		|Рекомендуется включить использование компоненты VanessaExt.","Прочее.Ввод текста");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯПрижимаюАктивноеОкноВлево()","ЯПрижимаюАктивноеОкноВлево","И я прижимаю активное окно влево");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯПрижимаюАктивноеОкноВправо()","ЯПрижимаюАктивноеОкноВправо","И я прижимаю активное окно вправо");
	

	Возврат ВсеТесты;
КонецФункции
	
&НаСервере
// Служебная функция.
Функция ПолучитьМакетСервер(ИмяМакета)
	ОбъектСервер = РеквизитФормыВЗначение("Объект");
	Возврат ОбъектСервер.ПолучитьМакет(ИмяМакета);
КонецФункции
	
&НаКлиенте
// Служебная функция для подключения библиотеки создания fixtures.
Функция ПолучитьМакетОбработки(ИмяМакета) Экспорт
	Возврат ПолучитьМакетСервер(ИмяМакета);
КонецФункции



///////////////////////////////////////////////////
//Работа со сценариями
///////////////////////////////////////////////////

&НаКлиенте
// Функция выполняется перед началом каждого сценария
Функция ПередНачаломСценария() Экспорт
	
КонецФункции

&НаКлиенте
// Функция выполняется перед окончанием каждого сценария
Функция ПередОкончаниемСценария() Экспорт
	
КонецФункции



///////////////////////////////////////////////////
//Реализация шагов
///////////////////////////////////////////////////

&НаКлиенте
//Когда Я нажимаю на кнопку диалога выбора файлов
//@ЯНажимаюНаКнопкуДиалогаВыбораФайлов()
Функция ЯНажимаюНаКнопкуДиалогаВыбораФайлов() Экспорт
	Результат = Ванесса.ВыполнитьSikuliСкрипт(Ванесса.Объект.КаталогИнструментов + "\tools\Sikuli\OpenDialog.sikuli");
	Ванесса.ПроверитьРавенство(Результат, 0 , "Произошло выполнение скрипта <OpenDialog>");
	
	Ванесса.СделатьДействияПриЗаписиИнструкции("толькоскриншот");
	
	Ванесса.Шаг("И я набираю текст ""#enter""");
	//Ванесса.sleep(2);
	Результат = Ванесса.ВыполнитьSikuliСкрипт(Ванесса.Объект.КаталогИнструментов + "\tools\Sikuli\OpenDialogClick.sikuli");
	Ванесса.ПроверитьРавенство(Результат, 0 , "Произошло выполнение скрипта <OpenDialogClick>");
КонецФункции

&НаКлиенте
//И в открывшемся окне я указываю путь к обработке Vanessa-behavior.epf
//@ВОткрывшемсяОкнеЯУказываюПутьКОбработкеVanessa_behaviorepf()
Функция ВОткрывшемсяОкнеЯУказываюПутьКОбработкеVanessa_behaviorepf() Экспорт
	Путь = Ванесса.Объект.КаталогИнструментов + "\vanessa-behavior.epf";
	
	Ванесса.Шаг("И я набираю текст""" + Путь + """");
	
	Ванесса.СделатьДействияПриЗаписиИнструкции();
	Ванесса.Шаг("И я набираю текст ""#enter""");
КонецФункции


&НаКлиенте
//И я набираю текст "текст"
//@ЯНабираюТекст(Парам01)
Функция ЯНабираюТекст(Знач Текст) Экспорт
	
	Если Ванесса.Объект.ИспользоватьКомпонентуVanessaExt Тогда
		Ванесса.ВнешняяКомпонентаДляСкриншотов.ЭмуляцияВводаТекста(Строка(Текст), 100);
		Возврат Неопределено;
	КонецЕсли;	
	
	Если ТипЗнч(Текст) = Тип("Массив") Тогда
		СобранныйТекст = "";
		Для Каждого Элем Из Текст Цикл
			Если СобранныйТекст <> "" Тогда
				СобранныйТекст = СобранныйТекст + Символы.ПС;
			КонецЕсли;	 
			СобранныйТекст = СобранныйТекст + Элем.Кол1;
		КонецЦикла;	
		
		Текст = СобранныйТекст;
	КонецЕсли;	 
	
	Если Текст = "#enter" Тогда
		ВременыйФайл = ПолучитьИмяВременногоФайла("txt");
		ЗТ = Новый ЗаписьТекста(ВременыйФайл,"UTF-8",,Истина); 
		ЗТ.Записать(Текст); 
		//ЗТ.Записать("#enter"); 
		ЗТ.Закрыть();
		
		Результат = Ванесса.ВыполнитьSikuliСкрипт(Ванесса.Объект.КаталогИнструментов + "\tools\Sikuli\TypeText.sikuli --args " + ВременыйФайл);
		Ванесса.ПроверитьРавенство(Результат, 0 , "Произошло выполнение скрипта <TypeText>");
		
		Возврат Неопределено;
	КонецЕсли;	 
	
	ИмяФайла = ПолучитьИмяВременногоФайла("txt");
	ЗТ = Новый ЗаписьТекста(ИмяФайла,"windows-1251",,Ложь); 
	ЗТ.Записать(Текст); 
	ЗТ.Закрыть();
	
	KeyboardType = Ванесса.Объект.КаталогИнструментов + "\tools\VideoTools\KeyboardType.exe";
	Если Не Ванесса.ФайлСуществуетКомандаСистемы(KeyboardType) Тогда
		ТекстСообщения = Ванесса.ПолучитьТекстСообщенияПользователю("Файл <%1> не найден.");
		ТекстСообщения = СтрЗаменить(ТекстСообщения,"%1",KeyboardType);
		ВызватьИсключение ТекстСообщения;
	КонецЕсли;	 
	
	Команда   = KeyboardType + " typespeed=100 ""filename=" + ИмяФайла + """";
	
	Результат = Ванесса.ВыполнитьКомандуОСБезПоказаЧерногоОкна(Команда);
	Ванесса.ПроверитьРавенство(Результат, 0 , "Выполнен шаг ЯЭмулируюНаборТекстаИзФайла <" + ИмяФайла + ">");
КонецФункции


&НаКлиенте
//И я прижимаю активное окно влево
//@ЯПрижимаюАктивноеОкноВлево()
Функция ЯПрижимаюАктивноеОкноВлево() Экспорт
	Результат = Ванесса.ВыполнитьSikuliСкрипт(Ванесса.Объект.КаталогИнструментов + "\tools\Sikuli\MoveActiveWindowLeft.sikuli");
	Ванесса.ПроверитьРавенство(Результат, 0 , "Произошло выполнение скрипта <MoveActiveWindowLeft>");
КонецФункции

&НаКлиенте
//И я прижимаю активное окно вправо
//@ЯПрижимаюАктивноеОкноВправо()
Функция ЯПрижимаюАктивноеОкноВправо() Экспорт
	Результат = Ванесса.ВыполнитьSikuliСкрипт(Ванесса.Объект.КаталогИнструментов + "\tools\Sikuli\MoveActiveWindowRight.sikuli");
	Ванесса.ПроверитьРавенство(Результат, 0 , "Произошло выполнение скрипта <MoveActiveWindowRight>");
КонецФункции


//окончание текста модуля
