﻿
///////////////////////////////////////////////////
//Служебные функции и процедуры
///////////////////////////////////////////////////

&НаКлиенте
// контекст фреймворка Vanessa-Behavior
Перем Ванесса;
 
&НаКлиенте
// Структура, в которой хранится состояние сценария между выполнением шагов. Очищается перед выполнением каждого сценария.
Перем Контекст Экспорт;
 
&НаКлиенте
// Структура, в которой можно хранить служебные данные между запусками сценариев. Существует, пока открыта форма Vanessa-Behavior.
Перем КонтекстСохраняемый Экспорт;

// Делает отключение модуля
&НаКлиенте
Функция ОтключениеМодуля() Экспорт

	Ванесса = Неопределено;
	Контекст = Неопределено;
	КонтекстСохраняемый = Неопределено;

КонецФункции

&НаКлиенте
// Функция экспортирует список шагов, которые реализованы в данной внешней обработке.
Функция ПолучитьСписокТестов(КонтекстФреймворкаBDD) Экспорт
	Ванесса = КонтекстФреймворкаBDD;
	
	ВсеТесты = Новый Массив;

	//описание параметров
	//Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,Снипет,ИмяПроцедуры,ПредставлениеТеста,ОписаниеШага,ТипШага,Транзакция,Параметр);

	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯОстанавливаюВыполнениеШаговВсехСценариев()","ЯОстанавливаюВыполнениеШаговВсехСценариев","Затем я останавливаю выполнение шагов всех сценариев.","Останавливает выполнение шагов. Другие сценарии выполнятся не будут.","");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯОстанавливаюВыполнениеВсехСценариев()","ЯОстанавливаюВыполнениеВсехСценариев","Затем я останавливаю выполнение всех сценариев.","Останавливает выполнение шагов. Другие сценарии выполнятся не будут.","Прочее.Остановить выполнение сценариев");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯОстанавливаюВыполнениеСценариевДаннойФичи()","ЯОстанавливаюВыполнениеСценариевДаннойФичи","Затем я останавливаю выполнение сценариев данной фичи.","Останавливает выполнение шагов в сценариях данной фичи. Другие фича файлы выполняться будут.","Прочее.Остановить выполнение сценариев");
	Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,"ЯОстанавливаюВыполнениеСценария(Парам1)","ЯОстанавливаюВыполнениеСценария","Затем я останавливаю выполнение сценария ""СтатусСценария""","Останавливает выполнение шагов в данном сценарии. Параметр ""СтатусСценария"" является необязательным. Если он передан, то в отчете Allure сценарию будет установлен данный статус. Доступные значения: Passed, Broken, Failed, Skipped, Pending.","Прочее.Остановить выполнение сценариев");

	Возврат ВсеТесты;
КонецФункции
	
&НаСервере
// Служебная функция.
Функция ПолучитьМакетСервер(ИмяМакета)
	ОбъектСервер = РеквизитФормыВЗначение("Объект");
	Возврат ОбъектСервер.ПолучитьМакет(ИмяМакета);
КонецФункции
	
&НаКлиенте
// Служебная функция для подключения библиотеки создания fixtures.
Функция ПолучитьМакетОбработки(ИмяМакета) Экспорт
	Возврат ПолучитьМакетСервер(ИмяМакета);
КонецФункции



///////////////////////////////////////////////////
//Работа со сценариями
///////////////////////////////////////////////////

&НаКлиенте
// Функция выполняется перед началом каждого сценария
Функция ПередНачаломСценария() Экспорт
	
КонецФункции

&НаКлиенте
// Функция выполняется перед окончанием каждого сценария
Функция ПередОкончаниемСценария() Экспорт
	
КонецФункции



///////////////////////////////////////////////////
//Реализация шагов
///////////////////////////////////////////////////

&НаКлиенте
//Затем я останавливаю выполнение шагов всех сценариев
//@ЯОстанавливаюВыполнениеШаговВсехСценариев()
Функция ЯОстанавливаюВыполнениеШаговВсехСценариев() Экспорт
	Ванесса.УстановитьФлагОстановкиВыполненияШаговОдногоСценария("Passed");
	Ванесса.УстановитьФлагОстановкиВыполненияШаговВсехСценариев();
КонецФункции

&НаКлиенте
//Затем я останавливаю выполнение всех сценариев
//@ЯОстанавливаюВыполнениеВсехСценариев()
Функция ЯОстанавливаюВыполнениеВсехСценариев() Экспорт
	ЯОстанавливаюВыполнениеШаговВсехСценариев();
КонецФункции

&НаКлиенте
//Затем я останавливаю выполнение сценариев данной фичи
//@ЯОстанавливаюВыполнениеСценариевДаннойФичи()
Функция ЯОстанавливаюВыполнениеСценариевДаннойФичи() Экспорт
	Ванесса.УстановитьФлагОстановкиВыполненияШаговОдногоСценария("Passed");
	Ванесса.УстановитьФлагОстановкиВыполненияСценариевДаннойФичи();
КонецФункции

&НаКлиенте
//Затем я останавливаю выполнение сценария
//@ЯОстанавливаюВыполнениеСценария()
Функция ЯОстанавливаюВыполнениеСценария(СтатусСценария = Неопределено) Экспорт
	Ванесса.УстановитьФлагОстановкиВыполненияШаговОдногоСценария(СтатусСценария);
КонецФункции
