﻿
///////////////////////////////////////////////////
//Служебные функции и процедуры
///////////////////////////////////////////////////

&НаКлиенте
// контекст фреймворка Vanessa-Automation
Перем Ванесса;
 
&НаКлиенте
// Структура, в которой хранится состояние сценария между выполнением шагов. Очищается перед выполнением каждого сценария.
Перем Контекст Экспорт;
 
&НаКлиенте
// Структура, в которой можно хранить служебные данные между запусками сценариев. Существует, пока открыта форма Vanessa-Automation.
Перем КонтекстСохраняемый Экспорт;

// Делает отключение модуля
&НаКлиенте
Функция ОтключениеМодуля() Экспорт

	Ванесса = Неопределено;
	Контекст = Неопределено;
	КонтекстСохраняемый = Неопределено;

КонецФункции

&НаКлиенте
// Функция экспортирует список шагов, которые реализованы в данной внешней обработке.
Функция ПолучитьСписокТестов(КонтекстФреймворкаBDD) Экспорт
	Ванесса = КонтекстФреймворкаBDD;
	
	//описание параметров
	//Ванесса.ДобавитьШагВМассивТестов(ВсеТесты,Снипет,ИмяПроцедуры,ПредставлениеТеста,ОписаниеШага,ТипШага,Транзакция,Параметр);

	Возврат Ванесса.МодульПодготовкаИЗагрузкаДанных().ПолучитьСписокТестов(Ванесса);
КонецФункции
	
&НаСервере
// Служебная функция.
Функция ПолучитьМакетСервер(ИмяМакета)
	ОбъектСервер = РеквизитФормыВЗначение("Объект");
	Возврат ОбъектСервер.ПолучитьМакет(ИмяМакета);
КонецФункции
	
&НаКлиенте
// Служебная функция для подключения библиотеки создания fixtures.
Функция ПолучитьМакетОбработки(ИмяМакета) Экспорт
	Возврат ПолучитьМакетСервер(ИмяМакета);
КонецФункции



///////////////////////////////////////////////////
//Работа со сценариями
///////////////////////////////////////////////////

&НаКлиенте
// Функция выполняется перед началом каждого сценария
Функция ПередНачаломСценария() Экспорт
	
КонецФункции

&НаКлиенте
// Функция выполняется перед окончанием каждого сценария
Функция ПередОкончаниемСценария() Экспорт
	
КонецФункции



///////////////////////////////////////////////////
//Реализация шагов
///////////////////////////////////////////////////


&НаКлиенте
Функция ЯЗапускаюОчисткуБазыДанных() Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯЗапускаюОчисткуБазыДанных();
КонецФункции 

&НаКлиенте
Функция ЯПроверяюИлиСоздаюДляСправочникаОбъекты(ИмяОбъекта, Значения) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПроверяюИлиСоздаюДляСправочникаОбъекты(ИмяОбъекта, Значения);
КонецФункции 

&НаКлиенте
Функция ЯПроверяюИлиСоздаюДляСправочникаОбъектыСОбменДаннымиЗагрузкаИстина(ИмяОбъекта, Значения) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПроверяюИлиСоздаюДляСправочникаОбъектыСОбменДаннымиЗагрузкаИстина(ИмяОбъекта, Значения);
КонецФункции 

&НаКлиенте
Функция ЯПроверяюИлиСоздаюДляПланаСчетовОбъекты(ИмяОбъекта, Значения) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПроверяюИлиСоздаюДляПланаСчетовОбъекты(ИмяОбъекта, Значения);
КонецФункции 

&НаКлиенте
Функция ЯПроверяюИлиСоздаюДляПланаСчетовОбъектыСОбменДаннымиЗагрузкаИстина(ИмяОбъекта, Значения) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПроверяюИлиСоздаюДляПланаСчетовОбъектыСОбменДаннымиЗагрузкаИстина(ИмяОбъекта, Значения);
КонецФункции 

&НаКлиенте
Функция ЯПроверяюИлиСоздаюДляДокументаОбъекты(ИмяОбъекта, Значения) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПроверяюИлиСоздаюДляДокументаОбъекты(ИмяОбъекта, Значения);
КонецФункции 

&НаКлиенте
Функция ЯПроверяюИлиСоздаюДляДокументаОбъектыСОбменДаннымиЗагрузкаИстина(ИмяОбъекта, Значения) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПроверяюИлиСоздаюДляДокументаОбъектыСОбменДаннымиЗагрузкаИстина(ИмяОбъекта, Значения);
КонецФункции 

&НаКлиенте
Функция ЯПроверяюИлиСоздаюДляПланаВидовХарактеристикОбъекты(ИмяОбъекта, Значения) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПроверяюИлиСоздаюДляПланаВидовХарактеристикОбъекты(ИмяОбъекта, Значения);
КонецФункции 

&НаКлиенте
Функция ЯПроверяюИлиСоздаюДляПланаВидовХарактеристикОбъектыСОбменДаннымиЗагрузкаИстина(ИмяОбъекта, Значения) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПроверяюИлиСоздаюДляПланаВидовХарактеристикОбъектыСОбменДаннымиЗагрузкаИстина(ИмяОбъекта, Значения);
КонецФункции 

&НаКлиенте
Функция ЯПроверяюИлиСоздаюДляРегистраСведенийЗаписи(ИмяРегистра, Значения) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПроверяюИлиСоздаюДляРегистраСведенийЗаписи(ИмяРегистра, Значения);
КонецФункции 

&НаКлиенте
Функция ЯПроверяюИлиСоздаюДляРегистраСведенийЗаписиСОбменДаннымиЗагрузкаИстина(ИмяРегистра, Значения) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПроверяюИлиСоздаюДляРегистраСведенийЗаписиСОбменДаннымиЗагрузкаИстина(ИмяРегистра, Значения);
КонецФункции 

&НаКлиенте
Функция ЯПроверяюИлиСоздаюДляРегистраСведенийЗаписиИспользуяНаборыЗаписей(ИмяРегистра, Значения) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПроверяюИлиСоздаюДляРегистраСведенийЗаписиИспользуяНаборыЗаписей(ИмяРегистра, Значения);
КонецФункции

&НаКлиенте
Функция ЯПроверяюИлиСоздаюДляРегистраСведенийЗаписиИспользуяНаборыЗаписейСОбменДаннымиЗагрузкаИстина(ИмяРегистра, Значения) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПроверяюИлиСоздаюДляРегистраСведенийЗаписиИспользуяНаборыЗаписейСОбменДаннымиЗагрузкаИстина(ИмяРегистра, Значения);
КонецФункции

&НаКлиенте
Функция ЯПроверяюИлиСоздаюДляРегистраНакопленийЗаписи(ИмяРегистра, Значения) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПроверяюИлиСоздаюДляРегистраНакопленийЗаписи(ИмяРегистра, Значения);
КонецФункции 

&НаКлиенте
Функция ЯПерезаполняюДляОбъектаТабличнуюЧасть(ИмяТабличнойЧасти, Значения) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПерезаполняюДляОбъектаТабличнуюЧасть(ИмяТабличнойЧасти, Значения);
КонецФункции 

&НаКлиенте
Функция ЯВыполняюКодИВставляюВПеременную(Код, ИмяПеременной) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯВыполняюКодИВставляюВПеременную(Код, ИмяПеременной);
КонецФункции 

&НаКлиенте
Функция ЯПерезаполняюКонстантуЗначением(ИмяКонстанты, ЗначениеКонстанты) Экспорт
	Ванесса.МодульПодготовкаИЗагрузкаДанных().ЯПерезаполняюКонстантуЗначением(ИмяКонстанты, ЗначениеКонстанты);
КонецФункции 

