﻿#Область ПрограммныйИнтерфейс

// Возвращает структуру данных реквизтов формы для работы Onboarding
Функция ДанныеРеквизитовФормыOnboarding(Форма) Экспорт
	
	МассивСтрок = Вычислить("СтрРазделить(Форма.ИмяФормы, ""."")");
	ТипОбъекта = МассивСтрок[0];
	ВидОбъекта = МассивСтрок[1];
	
	Результат = Новый Структура;
	Результат.Вставить("ДанныеМетаданных", Новый Структура);
	Результат.Вставить("ДанныеФормы", Новый Структура);
	ДанныеФормы = Результат.ДанныеФормы;
	
	Если ТипОбъекта = "Справочник"  ИЛИ ТипОбъекта = "Reference" Тогда
		ДополнитьДанныеМетаданных(Метаданные.Справочники[ВидОбъекта].СтандартныеРеквизиты, Результат.ДанныеМетаданных);
		ДополнитьДанныеМетаданных(Метаданные.Справочники[ВидОбъекта].Реквизиты, Результат.ДанныеМетаданных);
	КонецЕсли;	

	Если ТипОбъекта = "Документ"  ИЛИ ТипОбъекта = "Document" Тогда
		ДополнитьДанныеМетаданных(Метаданные.Документы[ВидОбъекта].СтандартныеРеквизиты, Результат.ДанныеМетаданных);
		ДополнитьДанныеМетаданных(Метаданные.Документы[ВидОбъекта].Реквизиты, Результат.ДанныеМетаданных);
	КонецЕсли;	
	
	Для Каждого ЭлементФормы Из Форма.Элементы Цикл
		ДанныеФормы.Вставить(ЭлементФормы.Имя, ДанныеЭлементаФормы(ЭлементФормы));
	КонецЦикла;	

	Возврат Результат;
	
КонецФункции	

#КонецОбласти

#Область СлужебныеПроцедурыИФункции

Процедура ДополнитьДанныеМетаданных(Реквизиты, Структура);
	
	Для Каждого ТекРеквизит Из Реквизиты Цикл
		Структура.Вставить(ТекРеквизит.Имя, ДанныеРеквизита(ТекРеквизит));
	КонецЦикла;	
	
КонецПроцедуры

Функция ДанныеРеквизита(Реквизит)
	
	Результат = Новый Структура;
	
	Результат.Вставить("Имя", Реквизит.Имя);
	Результат.Вставить("Синоним", Реквизит.Синоним);
	Результат.Вставить("Подсказка", Реквизит.Подсказка);
	
	Возврат Результат;
	
КонецФункции	

Функция ДанныеЭлементаФормы(ЭлементФормы)
	
	Результат = Новый Структура;
	
	Результат.Вставить("Имя", ЭлементФормы.Имя);
	Результат.Вставить("Заголовок", ЭлементФормы.Заголовок);
	
	Попытка
		Результат.Вставить("Подсказка", ЭлементФормы.Подсказка);
	Исключение
		Результат.Вставить("Подсказка", Неопределено);
	КонецПопытки;
	
	Попытка
		Результат.Вставить("ПутьКДанным", ЭлементФормы.ПутьКДанным);
	Исключение
		Результат.Вставить("ПутьКДанным", Неопределено);
	КонецПопытки;    
	
	Попытка
		Результат.Вставить("РасширеннаяПодсказка", ЭлементФормы.РасширеннаяПодсказка.Заголовок);
	Исключение
		Результат.Вставить("РасширеннаяПодсказка", Неопределено);
	КонецПопытки;
	
	Возврат Результат;
	
КонецФункции	

#КонецОбласти